/*
	http://www.cs.nmsu.edu/~jeffery/courses/371/cppunit/money_example.html
*/

#ifdef	__ACTIVATSP_CPPUNIT_BUILD

#include "ActivaTSP_Test_Adapter.h"


// Registers the fixture into the 'registry'
CPPUNIT_TEST_SUITE_REGISTRATION( ActivaTSP_Test_Adapter );


void 
ActivaTSP_Test_Adapter::setUp()
{
	m_pxCstaListener	= new Test_ASTCstaListener();
	m_pxCstaProvider = ASTCstaProvider::Create(m_pxCstaListener, &m_xLogger);
}


void 
ActivaTSP_Test_Adapter::tearDown()
{
	delete m_pxCstaProvider;

	delete m_pxCstaListener;
}


void 
ActivaTSP_Test_Adapter::test_case_518_calls_416()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;

	long xref = m_pxCstaProvider->OpenMonitor("518");

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/518-0820ad78
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridnum DATA: 518
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: device
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.56
	*/
	ev.m_channel = "SIP/518-0820ad78";
	ev.m_state = "Down";
	ev.m_callerId = "518";
	ev.m_callerIdName = "device";
	ev.m_uniqueId = "1249314924.56";

	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/518-0820ad78
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: state DATA: Ring
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: callerid DATA: 518
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: device
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.56
	*/
	ev.m_channel = "SIP/518-0820ad78";
	ev.m_state = "Ring";
	ev.m_callerId = "518";
	ev.m_callerIdName = "device";
	ev.m_uniqueId = "1249314924.56";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/518-0820ad78
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: callerid DATA: 517
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: jcosta softphone
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.56
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
	*/
	ev.m_callerIdName = "my softphone";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/416-b6e17dc8
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.57
	*/
	ev.m_channel = "SIP/416-b6e17dc8";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249314924.57";

	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Dial
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: source DATA: SIP/518-0820ad78
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: destination DATA: SIP/416-b6e17dc8
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: callerid DATA: 517
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: jcosta softphone
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: srcuniqueid DATA: 1249314924.56
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: destuniqueid DATA: 1249314924.57
	*/
	ev.m_callerId = "518";
	ev.m_callerIdName = "my softphone";
	ev.m_srcUniqueId = "1249314924.56";
	ev.m_destUniqueId = "1249314924.57";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/416-b6e17dc8
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: callerid DATA: 416
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: <Unknown>
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.57
	08/03/09 17:55:19 [7728] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
	*/
	ev.m_channel = "SIP/416-b6e17dc8";
	ev.m_callerId = "416";
	ev.m_callerIdName = "<Unknown>";
	ev.m_uniqueId = "1249314924.57";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/416-b6e17dc8
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: state DATA: Ringing
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: callerid DATA: 416
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/03/09 17:55:20 [7728] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249314924.57
	*/
	ev.m_channel = "SIP/416-b6e17dc8";
	ev.m_state = "Ringing";
	ev.m_callerId = "416";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249314924.57";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// alerting
	Test_Event lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice=="416");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice=="416");

	/*
	08/03/09 17:55:20 [7728] TRACE0 [ASTCallMap] DUMP OF ASTERISK CALLS MAP: {UNIQUEID} => call info:
	08/03/09 17:55:20 [7728] TRACE0 [ASTCallMap]   {1249314924.56}.518 numDevice=518 callID=7 state=Ring chann=SIP/518-0820ad78 CID=517 CIDName=jcosta softphone lastRedir= source= userData= cause=0
	08/03/09 17:55:20 [7728] TRACE0 [ASTCallMap]   {1249314924.57}.416 numDevice=416 callID=7 state=Ringing chann=SIP/416-b6e17dc8 CID=416 CIDName=jcosta softphone lastRedir= source=1249314924.56 userData= cause=0
	*/
	pAC = m_pxCstaProvider->GetAsteriskCall("1249314924.56");
	std::string	address = pAC->GetAddress();

	CPPUNIT_ASSERT(pAC->GetAddress()=="518");
	CPPUNIT_ASSERT(pAC->GetState()== call_state_ring );
	CPPUNIT_ASSERT(pAC->GetSourceUniqueId()=="");

	pAC = m_pxCstaProvider->GetAsteriskCall("1249314924.57");
	CPPUNIT_ASSERT(pAC->GetAddress()=="416");
	CPPUNIT_ASSERT(pAC->GetState()== call_state_ringing );
	CPPUNIT_ASSERT(pAC->GetSourceUniqueId()=="1249314924.56");

	m_pxCstaProvider->CloseMonitor(xref);

}

void 
ActivaTSP_Test_Adapter::test_case_109_calls_103()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newchannel
	07/31/09 11:57:04 [3056] TRACE [ASTCallMap] Create AsteriskCall with uniqueId = 1249034362.11909 and callid =14320
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not contains UserData
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not containsCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call is NOT predictive
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11909}.callerID=109, callerIdName=device
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11909}.channel=SIP/109-b7507b28, address=109
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   state = DOWN => do nothing
	*/
	ev.m_channel = "SIP/109-b7507b28";
	ev.m_state = "Down";
	ev.m_callerId = "109";
	ev.m_callerIdName = "device";
	ev.m_uniqueId = "1249034362.11909";

	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newstate
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not contains UserData
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not containsCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call is NOT predictive
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11909}.callerID=109, callerIdName=device
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   state = RING => Send ORIGINATED to {1249034362.11909}.address=109
	*/
	ev.m_channel = "SIP/518-0820ad78";
	ev.m_state = "Ring";
	ev.m_callerId = "109";
	ev.m_callerIdName = "device";
	ev.m_uniqueId = "1249034362.11909";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newcallerid
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not contains UserData
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not containsCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call is NOT predictive
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11909}.device to new calleridname 109
	*/
	ev.m_callerIdName = "109";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newchannel
	07/31/09 11:57:04 [3056] TRACE [ASTCallMap] Create AsteriskCall with uniqueId = 1249034362.11910 and callid =14321
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11910}.callerID=, callerIdName=
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11910}.channel=Local/103@from-internal-610d,1, address=103
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   state = DOWN => do nothing
	*/
	ev.m_channel = "Local/103@from-internal-610d,1";
	ev.m_callerId = "";
	ev.m_callerIdName = "";
	ev.m_uniqueId = "1249034362.11910";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newchannel
	07/31/09 11:57:04 [3056] TRACE [ASTCallMap] Create AsteriskCall with uniqueId = 1249034362.11911 and callid =14322
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11911}.callerID=, callerIdName=
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11911}.channel=Local/103@from-internal-610d,2, address=103
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]  link call {1249034362.11911} with call {1249034362.11910}
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   state = RING => Send ORIGINATED to {1249034362.11911}.address=103
	*/
	ev.m_channel = "Local/103@from-internal-610d,2";
	ev.m_callerId = "";
	ev.m_callerIdName = "";
	ev.m_uniqueId = "1249034362.11911";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => dial
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   linked calls {1249034362.11909} -> {1249034362.11910}
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not contains UserData
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not containsCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call is NOT predictive
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Dial event don't contain callid, we try to get it using GetLogicCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call logicCallId(14320)
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11909}.14320 to new callId 14320
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11910}.14321 to new callId 14320
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] overriding {1249034362.11909}. to new callerid 109
	*/
	ev.m_callerId = "103";		// no en trazas ??
	ev.m_callerIdName = "<unknown>";	// no en trazas ??
	ev.m_srcUniqueId = "1249034362.11909";
	ev.m_destUniqueId = "1249034362.11910";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newcallerid
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11910}. to new callerId 108
	*/
	ev.m_channel = "";				// no en trazas ?
	ev.m_callerId = "108";
	ev.m_callerIdName = "108";		// no en trazas ?
	ev.m_uniqueId = "1249034362.11910";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newchannel
	07/31/09 11:57:04 [3056] TRACE [ASTCallMap] Create AsteriskCall with uniqueId = 1249034362.11912 and callid =14323
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11912}.callerID=, callerIdName=
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   setting {1249034362.11912}.channel=SIP/103-08888408, address=103
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   state = DOWN => do nothing
	*/
	ev.m_channel = "SIP/103-08888408";
	ev.m_callerId = "";
	ev.m_callerIdName = "";
	ev.m_uniqueId = "1249034362.11912";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => dial
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   linked calls {1249034362.11911} -> {1249034362.11912}
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not contains UserData
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call does not containsCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call is NOT predictive
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Dial event don't contain callid, we try to get it using GetLogicCallId
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] Call logicCallId(14320)
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11911}.14322 to new callId 14320
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11912}.14323 to new callId 14320
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider] overriding {1249034362.11911}. to new callerid 109
	*/
	ev.m_callerId = "";		// no en trazas ??
	ev.m_callerIdName = "";	// no en trazas ??
	ev.m_srcUniqueId = "1249034362.11911";
	ev.m_destUniqueId = "1249034362.11912";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newcallerid
	07/31/09 11:57:04 [3056] TRACE [ASTCstaProvider]   overriding {1249034362.11912}. to new callerId 103
	*/
	ev.m_channel = "";				// no en trazas ?
	ev.m_callerId = "103";
	ev.m_callerIdName = "103";		// no en trazas ?
	ev.m_uniqueId = "1249034362.11912";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	07/31/09 11:57:04 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => unlink
	*/
	m_pxCstaProvider->OnUnlinkEvent(ev);

	/*
	// tratamiento de nuevo evento
	07/31/09 11:57:05 [3056] TRACE [ASTProvider] ASTProvider::HandleEvent => newstate
	07/31/09 11:57:05 [3056] TRACE [ASTCstaProvider]   state = RINGING => Send ALERTING to {1249034362.11912}.address=103
	07/31/09 11:57:05 [3056] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionAlerting uniqueId=1249034362.11912, address=103
	07/31/09 11:57:05 [3056] TRACE [ASTCallMap] ASTCallMap::GetSourceCall()
	07/31/09 11:57:05 [3056] TRACE [ASTCallMap] GetSourceCall TOO DEEP. Returning call eddfb0
	*/
	ev.m_channel = "";		// no en trazas
	ev.m_state = "Ringing";
	ev.m_callerId = "416";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249034362.11912";
	m_pxCstaProvider->OnNewStateEvent(ev);

	pAC = m_pxCstaProvider->GetAsteriskCall("1249034362.11912");
	std::string	address = pAC->GetAddress();
}


void 
ActivaTSP_Test_Adapter::test_predictive_1249560258_19156()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("5858");

	/*
	in a predictive calls we need to set callid in userdata in order to establish a fine callmap.
	see: originate
	So in test we need to simulate this artificially:
		callid = m_callMap.GetNewCallId();
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	DWORD	myCallid = m_pxCstaProvider->m_callMap.GetNewCallId();
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(myCallid, "5858" /*callingDevice*/, INITIALIZED );


	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_state = "Down";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,2
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Ring
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19157
		08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,2";
	ev.m_state = "Ring";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560258.19157";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	08/06/09 14:02:00 [4168] TRACE [ASTCstaProvider]   setting {1249560258.19157}.callerID=, callerIdName=
	08/06/09 14:02:00 [4168] TRACE [ASTCstaProvider]   setting {1249560258.19157}.channel=Local/1922393987@from-internal-8ca7,2, address=1922393987
	08/06/09 14:02:00 [4168] TRACE [ASTCstaProvider]  link call {1249560258.19157} with call {1249560258.19156}
	08/06/09 14:02:00 [4168] TRACE [ASTCstaProvider]   state = RING => Send ORIGINATED to {1249560258.19157}.address=1922393987
	*/
	pAC = m_pxCstaProvider->GetAsteriskCall("1249560258.19157");
	CPPUNIT_ASSERT( pAC->GetChannel()=="Local/1922393987@from-internal-8ca7,2");
	CPPUNIT_ASSERT( pAC->GetSourceUniqueId()=="1249560258.19156");

	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9003#D#Id=12476
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
		08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "#U=icr.m.vd.9003#D#Id="+ToString( myCallid );	
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560258.19156")->GetCallId() == myCallid);

	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9003#D#Id=12476
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
		08/06/09 14:02:00 [4168] TRACE [ASTProvider] ASTProvider::HandleEvent => newcallerid
		08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "#U=icr.m.vd.9003#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,2
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 935459119
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <Unknown>
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19157
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,2";
	ev.m_callerId = "935459119";
	ev.m_callerIdName = "<Unknown>";
	ev.m_uniqueId = "1249560258.19157";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);




	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/toColt-08c1d8f8
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560259.19158
		08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "SIP/toColt-08c1d8f8";
	ev.m_state = "Down";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560259.19158";
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Dial
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: source DATA: Local/1922393987@from-internal-8ca7,2
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: destination DATA: SIP/toColt-08c1d8f8
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 935459119
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: srcuniqueid DATA: 1249560258.19157
		08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: destuniqueid DATA: 1249560259.19158
		08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_srcUniqueId = "1249560258.19157";
	ev.m_destUniqueId = "1249560259.19158";
	ev.m_callerId = "935459119";		
	ev.m_callerIdName = "<unknown>";	
	m_pxCstaProvider->OnDialEvent(ev);


	AsteriskCall	*pAC2 = m_pxCstaProvider->GetAsteriskCall("1249560258.19157");
	AsteriskCall	*pAC3 = m_pxCstaProvider->GetAsteriskCall("1249560259.19158");

	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560258.19157")->GetCallId() == myCallid);
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560259.19158")->GetCallId() == myCallid);



	/*
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/toColt-08c1d8f8
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <Unknown>
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560259.19158
	08/06/09 14:02:00 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
	08/06/09 14:02:00 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "SIP/toColt-08c1d8f8";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "<Unknown>";		
	ev.m_uniqueId = "1249560259.19158";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560259.19158")->GetCallerId() == "1922393987");



	/*
	08/06/09 14:02:01 [4168] TRACE0 [ASTCallMap]   {1249560258.19156}.1922393987 numDevice=1922393987 callID=12476 state=Down chann=Local/1922393987@from-internal-8ca7,1 CID=1922393987 CIDName= lastRedir= source= userData=icr.m.vd.9003 cause=0
	08/06/09 14:02:01 [4168] TRACE0 [ASTCallMap]   {1249560258.19157}.1922393987 numDevice=1922393987 callID=12476 state=Ring chann=Local/1922393987@from-internal-8ca7,2 CID=935459119 CIDName=<unknown> lastRedir= source=1249560258.19156 userData= cause=0
	08/06/09 14:02:01 [4168] TRACE0 [ASTCallMap]   {1249560259.19158}.tocolt numDevice=tocolt callID=12476 state=Down chann=SIP/toColt-08c1d8f8 CID=1922393987 CIDName=<unknown> lastRedir= source=1249560258.19157 userData= cause=0
	*/

	// assert nice call-map::
	// 1249560258.19157 -> 1249560258.19156 this relation is based on CSTA link: #Id=12476
	// see it could also be based on uuid pattern? xxxx.yyy -> xxxx.zzz
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560258.19157")->GetStateString() == "Ring" );
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560258.19157")->GetSourceUniqueId() == "1249560258.19156" );
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560259.19158")->GetSourceUniqueId() == "1249560258.19157" );


	/*
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/toColt-08c1d8f8
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:16 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560259.19158

	08/06/09 14:02:16 [4168] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionConnected uniqueId=1249560259.19158, address=tocolt
	08/06/09 14:02:16 [4168] TRACE [ASTCallMap] ASTCallMap::GetSourceCall()
	08/06/09 14:02:16 [4168] TRACE [ASTCallMap]   SourceCall is 1249560258.19156
	08/06/09 14:02:16 [4168] TRACE [ASTCallMap] GetCIDInfoFromSourceCall(1249560259.19158)

	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]     sending ESTABLISHED to xref=5, {1249560259.19158}.tocolt callid=12476 lastRedirection= userData=icr.m.vd.9003
	08/06/09 14:02:17 [4168] TRACE [TAPIProvider] OnEstablished xref=5 callId=12476, establishedDevice=tocolt, callerId=1922393987, callerIdName=, calledDevice =, lastRedirectingDevice=, userData=icr.m.vd.9003 cause=0
	08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "SIP/toColt-08c1d8f8";
	ev.m_state = "Up";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560258.19158";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,2
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 935459119
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19157
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,2";
	ev.m_state = "Up";
	ev.m_callerId = "935459119";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560258.19157";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Link
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel1 DATA: Local/1922393987@from-internal-8ca7,2
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel2 DATA: SIP/toColt-08c1d8f8
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid1 DATA: 1249560258.19157
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid2 DATA: 1249560259.19158
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid1 DATA: 935459119
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid2 DATA: 1922393987
	08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "";
	ev.m_state = "";
	ev.m_callerId = "";
	ev.m_callerIdName = "";
	ev.m_srcUniqueId="1249560258.19157"; 
	ev.m_destUniqueId="1249560258.19158";
	m_pxCstaProvider->OnLinkEvent(ev);

	/*
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9003#D#Id=12476
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
		08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_state = "Up";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "#U=icr.m.vd.9003#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnNewStateEvent(ev);


	/*
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: 5858:#U=icr.m.vd.9003#D#Id=12476
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
		08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "5858:#U=icr.m.vd.9003#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Join
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: 5858:#U=icr.m.vd.9003#D#Id=12476
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: queue DATA: 5858
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: position DATA: 1
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: count DATA: 1
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156

	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]     sending QUEUED to xref=5, {1249560258.19156}.5858 userData=icr.m.vd.9003
	08/06/09 14:02:17 [4168] TRACE [TAPIProvider] OnQueued xref=5 callId=12476, queuedDevice=5858, queue=5858, callerId=1922393987, callerIdName=5858:, userData=icr.m.vd.9003 cause=0
	08/06/09 14:02:17 [4168] TRACE [TAPIProvider]   LINECALLSTATE_ACCEPTED htapicall=10014 htapiLine=10144
	08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "5858:#U=icr.m.vd.9003#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560258.19156";
	ev.m_queue = "5858";
	ev.m_position = "1";
	ev.m_count = "1";
	m_pxCstaProvider->OnJoinEvent(ev);

	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/346-08b04fd0
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19168
	*/
	ev.m_channel = "SIP/346-08b04fd0";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560275.19168";
	ev.m_state = "Down";
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/346@from-internal-16db,1
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19166
	*/
	ev.m_channel = "Local/346@from-internal-16db,1";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560275.19166";
	ev.m_state = "Down";
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/346@from-internal-16db,2
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Ring
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19167
	08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/346@from-internal-16db,2";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560275.19167";
	ev.m_state = "Ring";
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
	08/06/09 14:02:17 [4168] TRACE [ASTProvider] ASTProvider::HandleEvent => newchannel
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap] Create AsteriskCall with uniqueId = 1249560275.19167 and callid =12490
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   setting {1249560275.19167}.callerID=, callerIdName=
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   setting {1249560275.19167}.channel=Local/346@from-internal-16db,2, address=346
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]  link call {1249560275.19167} with call {1249560275.19166}
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   state = RING => Send ORIGINATED to {1249560275.19167}.address=346
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionOriginated uniqueId=1249560275.19167, address=346
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   event minimization RULE-9: Do not send EVENTS to local channels
	*/
	CPPUNIT_ASSERT(m_pxCstaProvider->GetAsteriskCall("1249560275.19167")->GetSourceUniqueId()=="1249560275.19166");


	/*
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Dial
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: source DATA: Local/346@from-internal-16db,2
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: destination DATA: SIP/346-08b04fd0
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: 5858:#U=icr.m.vd.9003#D#Id=12476
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: srcuniqueid DATA: 1249560275.19167
		08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: destuniqueid DATA: 1249560275.19168
		08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "Local/346@from-internal-16db,2";
	ev.m_srcUniqueId = "1249560275.19167";
	ev.m_destUniqueId = "1249560275.19168";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "5858:#U=icr.m.vd.9003#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560275.19168";
	ev.m_state = "";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider] overriding {1249560275.19167}. to new callerid 1922393987
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap] ASTCallMap::GetSourceCall()
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap]   SourceCall is 1249560275.19166
	*/
	CPPUNIT_ASSERT(m_pxCstaProvider->GetAsteriskCall("1249560275.19167")->GetCallerId()=="1922393987");
	CPPUNIT_ASSERT(m_pxCstaProvider->GetAsteriskCall("1249560275.19167")->GetSourceUniqueId()=="1249560275.19166");

	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/346-08b04fd0
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 346
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <Unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19168
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
	08/06/09 14:02:17 [4168] TRACE [ASTProvider] ASTProvider::HandleEvent => newcallerid
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   overriding {1249560275.19168}. to new callerId 346
	08/06/09 14:02:17 [4168] TRACE [ASTProvider]  <== asterisk protocol event _______________________________
	*/
	ev.m_channel = "SIP/346-08b04fd0";
	ev.m_uniqueId = "1249560275.19168";
	ev.m_callerId = "346";
	ev.m_callerIdName = "<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);


	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/346-08b04fd0
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Ringing
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 346
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19168
	08/06/09 14:02:17 [4168] TRACE [ASTProvider] ASTProvider::HandleEvent => newstate
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]   state = RINGING => Send ALERTING to {1249560275.19168}.address=346
	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionAlerting uniqueId=1249560275.19168, address=346
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap] ASTCallMap::GetSourceCall()
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap]   SourceCall is 1249560258.19156
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap] GetCIDInfoFromSourceCall(1249560275.19168)
	08/06/09 14:02:17 [4168] TRACE [ASTCallMap]   Exiting with cid/cidname/userData=1922393987/5858:/icr.m.vd.9003

	08/06/09 14:02:17 [4168] TRACE [ASTCstaProvider]     sending ALERTING to xref=5, {1249560275.19168}.346 callid=12476 lastRedirection=5858 userData=icr.m.vd.9003
	08/06/09 14:02:17 [4168] TRACE [TAPIProvider] OnAlerting xref=5 callId=12476, alertingDevice=346, callerId=1922393987, callerIdName=5858:, calledID=5858 userData=icr.m.vd.9003 cause=0
	*/
	ev.m_channel = "SIP/346-08b04fd0";
	ev.m_state = "Ringing";
	ev.m_callerId = "346";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560275.19168";
	m_pxCstaProvider->OnNewStateEvent(ev);


	// 08/06/09 14:02:17 [4168] TRACE0 [ASTCallMap]   {1249560275.19168}.346 numDevice=346 callID=12476 state=Ringing chann=SIP/346-08b04fd0 CID=346 CIDName=5858: lastRedir= source=1249560275.19167 userData=icr.m.vd.9003 cause=0

	// alerting
	Test_Event lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	DWORD	myCallId = lastEvent.m_callId ;		// for later use

	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "346");
	CPPUNIT_ASSERT(lastEvent.m_callerId == "1922393987");
	CPPUNIT_ASSERT(lastEvent.m_callerIdName == "5858:");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "5858");
	CPPUNIT_ASSERT(lastEvent.m_userData == "icr.m.vd.9003");


	/*
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: SIP/346-08b04fd0
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 346
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:02:17 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19168
	*/
	ev.m_channel = "SIP/346-08b04fd0";
	ev.m_state = "Up";
	ev.m_callerId = "346";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560275.19168";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/06/09 14:02:18 [4168] TRACE [ASTCstaProvider]     sending ESTABLISHED to xref=5, {1249560275.19168}.346 callid=12476 lastRedirection=5858 userData=icr.m.vd.9003
	08/06/09 14:02:18 [4168] TRACE [TAPIProvider] OnEstablished xref=5 callId=12476, establishedDevice=346, callerId=1922393987, callerIdName=5858:, calledDevice =5858, lastRedirectingDevice=5858, userData=icr.m.vd.9003 cause=0
	*/
	// established
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETEstablished);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallId );
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "346");
	CPPUNIT_ASSERT(lastEvent.m_callerId == "1922393987");
	CPPUNIT_ASSERT(lastEvent.m_callerIdName == "5858:");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "5858");
	CPPUNIT_ASSERT(lastEvent.m_userData == "icr.m.vd.9003");

	/*
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/346@from-internal-16db,2
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: 5858:#U=icr.m.vd.9003#D#Id=12476
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19167
	*/
	ev.m_channel = "Local/346@from-internal-16db,2";
	ev.m_state = "Up";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "5858:#U=icr.m.vd.9003#D#Id="+ToString(myCallid);;
	ev.m_uniqueId = "1249560275.19167";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Link
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel1 DATA: Local/346@from-internal-16db,2
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel2 DATA: SIP/346-08b04fd0
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid1 DATA: 1249560275.19167
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid2 DATA: 1249560275.19168
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid1 DATA: 1922393987
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid2 DATA: 346
	08/06/09 14:02:18 [4168] TRACE [ASTProvider] ASTProvider::HandleEvent => link
	08/06/09 14:02:18 [4168] TRACE [ASTCstaProvider]   set {1249560275.19168}.lastRedirectionDevice=
	*/
	ev.m_channel = "";
	ev.m_state = "";
	ev.m_callerId = "";
	ev.m_callerIdName = "";
	ev.m_srcUniqueId="1249560275.19167"; 
	ev.m_destUniqueId="1249560275.19168";
	m_pxCstaProvider->OnLinkEvent(ev);

	/*
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/346@from-internal-16db,1
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Up
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1922393987
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: 5858:#U=icr.m.vd.9003#D#Id=12476
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560275.19166
	*/
	ev.m_channel = "Local/346@from-internal-16db,1";
	ev.m_state = "Up";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "5858:#U=icr.m.vd.9003#D#Id="+ToString(myCallid);;
	ev.m_uniqueId = "1249560275.19166";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Leave
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1922393987@from-internal-8ca7,1
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: queue DATA: 5858
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: count DATA: 0
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560258.19156
	*/
	ev.m_channel = "Local/1922393987@from-internal-8ca7,1";
	ev.m_queue = "5858";
	ev.m_count = "0";
	ev.m_uniqueId = "1249560258.19156";
	m_pxCstaProvider->OnLeaveEvent(ev);

	/*
	08/06/09 14:02:18 [4168] TRACE [ASTCstaProvider]     sending DIVERTED to xref=5, {1249560258.19156}.5858
	...
	08/06/09 14:02:18 [4168] TRACE [TAPIProvider] OnDiverted xref=5 callId=12476, divertedDevice=5858, divertingDevice=5858, callerId=1922393987, callerIdName=5858:, userData=, cause=0
	*/
	// diverted
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETDiverted);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallId );
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "5858");
	CPPUNIT_ASSERT(lastEvent.m_callerId == "1922393987");

	/*
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Link
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel1 DATA: Local/1922393987@from-internal-8ca7,1
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: channel2 DATA: Local/346@from-internal-16db,1
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid1 DATA: 1249560258.19156
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: uniqueid2 DATA: 1249560275.19166
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid1 DATA: 1922393987
	08/06/09 14:02:18 [4168] TRACE0 [ASTProvider] HEADER: callerid2 DATA: 1922393987
	*/
	ev.m_channel = "";
	ev.m_state = "";
	ev.m_callerId = "1922393987";
	ev.m_callerIdName = "";
	ev.m_srcUniqueId="1249560258.19156"; 
	ev.m_destUniqueId="1249560275.19166";
	m_pxCstaProvider->OnLinkEvent(ev);


	// alerting
//	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
//	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETEstablished);

	m_pxCstaProvider->CloseMonitor(xref);

}


/*
Sometimes a NewChannel with no data in channel element is received.
This used to produce an entry in call-map that never gets dropped.
sample:
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: 
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
08/06/09 14:03:36 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560354.19202
*/
void	ActivaTSP_Test_Adapter::void_channel_newchannelevent()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("5858");

	size_t	sizeMapSize = m_pxCstaProvider->m_callMap.Size();

	ev.m_channel = "";		// no data
	ev.m_state = "Down";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560354.19202";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	// assert no item has been added to call-map
	CPPUNIT_ASSERT(sizeMapSize == m_pxCstaProvider->m_callMap.Size());

	m_pxCstaProvider->CloseMonitor(xref);
}


void ActivaTSP_Test_Adapter::predictive_User_alerting_no_answer_1249560633_19283()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("5858");

	/*
	08/06/09 14:08:14 [348] TRACE [ASTProvider] ASTProvider::SendCommand => 
	Action: Originate
	Channel: Local/1650798345@from-internal/n
	Exten: 5858
	Priority: 1
	Callerid:       #U=icr.m.vd.9001#D#Id=12621 <1650798345>
	Context: from-internal
	Variable: originating=1650798345
	ActionID: 3298
	Timeout: 22000
	Async: 1

	in a predictive calls we need to set callid in userdata in order to establish a fine callmap.
	see: originate
	So in test we need to simulate this artificially:
		callid = m_callMap.GetNewCallId();
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	DWORD	myCallid = m_pxCstaProvider->m_callMap.GetNewCallId();
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(myCallid, "5858" /*callingDevice*/, INITIALIZED );


/*
	08/06/09 14:08:14 [348] TRACE [TAPIProvider]  makecall or makepredictivecall success
	08/06/09 14:08:14 [348] TRACE [TAPIProvider]   NEW callId=12621 for htapicall=10552 and hdcall=5B1EE8
	08/06/09 14:08:14 [348] TRACE [TAPIProvider]   returning dwRequestId 67164

	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,1
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19283
*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,1";		
	ev.m_state = "Down";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560633.19283";
	m_pxCstaProvider->OnNewChannelEvent(ev);

/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,2
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Ring
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19284
*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,2";		
	ev.m_state = "Ring";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560633.19284";
	m_pxCstaProvider->OnNewChannelEvent(ev);

/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,1
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9001#D#Id=12621
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19283
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,1";		
	ev.m_callerId = "1650798345";
	ev.m_callerIdName = "#U=icr.m.vd.9001#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560633.19283";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);



/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,1
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9001#D#Id=12621
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19283
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,1";		
	ev.m_callerId = "1650798345";
	ev.m_callerIdName = "#U=icr.m.vd.9001#D#Id="+ToString(myCallid);
	ev.m_uniqueId = "1249560633.19283";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);


/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newchannel
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: WOOMERA/g2/650798345/o-550e
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Down
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19285
*/
	ev.m_channel = "WOOMERA/g2/650798345/o-550e";		
	ev.m_state = "Down";
	ev.m_callerId = "<unknown>";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560633.19285";
	m_pxCstaProvider->OnNewChannelEvent(ev);

/*
	08/06/09 14:08:14 [4168] TRACE [ASTCstaProvider]   setting {1249560633.19285}.callerID=, callerIdName=
	08/06/09 14:08:14 [4168] TRACE [ASTCstaProvider]   setting {1249560633.19285}.channel=WOOMERA/g2/650798345/o-550e, address=g2/650798345/o
*/
	pAC = m_pxCstaProvider->GetAsteriskCall("1249560633.19285");
	CPPUNIT_ASSERT(pAC);


/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Dial
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: source DATA: Local/1650798345@from-internal-f1d6,2
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: destination DATA: WOOMERA/g2/650798345/o-550e
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9001#D#Id=12621
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: srcuniqueid DATA: 1249560633.19284
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: destuniqueid DATA: 1249560633.19285
*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,2";
	ev.m_srcUniqueId = "1249560633.19284";
	ev.m_destUniqueId = "1249560633.19285";
	ev.m_callerId = "1650798345";
	ev.m_callerIdName = "#U=icr.m.vd.9001#D#Id="+ToString(myCallid);
	m_pxCstaProvider->OnDialEvent(ev);


/*
	08/06/09 14:08:14 [4168] TRACE [ASTCstaProvider]   overriding {1249560633.19284}.12623 to new callId 12621
	08/06/09 14:08:14 [4168] TRACE [ASTCstaProvider]   overriding {1249560633.19285}.12624 to new callId 12621
*/
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560633.19284")->GetCallId()==myCallid  );
	CPPUNIT_ASSERT( m_pxCstaProvider->GetAsteriskCall("1249560633.19285")->GetCallId()==myCallid  );


/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newcallerid
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: WOOMERA/g2/650798345/o-550e
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <Unknown>
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19285
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: cid-callingpres DATA: 0 (Presentation Allowed, Not Screened)
*/
	ev.m_channel = "WOOMERA/g2/650798345/o-550e";		
	ev.m_callerId = "1650798345";
	ev.m_callerIdName = "<Unknown>";
	ev.m_uniqueId = "1249560633.19285";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);


/*
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Rename
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: oldname DATA: WOOMERA/g2/650798345/o-550e
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: newname DATA: WOOMERA/g2/4
	08/06/09 14:08:14 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19285
*/
	ev.m_oldname = "WOOMERA/g2/650798345/o-550e";		
	ev.m_newname = "WOOMERA/g2/4" ;
	ev.m_uniqueId = "1249560633.19285";
	m_pxCstaProvider->OnRenameEvent(ev);

	/*
		08/06/09 14:08:15 [4168] TRACE [ASTCstaProvider]     sending CONNCLEARED to xref=5, {1249560633.19285}.5858 callid=12621
		08/06/09 14:08:15 [4168] TRACE [TAPIProvider] OnConnectionCleared xref=5 callId=12621, releasingDevice=g2/650798345/o cause=0
	*/
/*	Test_Event	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid );*/

	/*
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Newstate
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: WOOMERA/g2/4
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: state DATA: Ringing
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: <unknown>
		08/06/09 14:08:15 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19285
	*/
	ev.m_channel = "WOOMERA/g2/4";
	ev.m_state = "Ringing";
	ev.m_callerId = "1650798345";
	ev.m_callerIdName = "<unknown>";
	ev.m_uniqueId = "1249560633.19285";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/06/09 14:08:15 [4168] TRACE [ASTCstaProvider]     sending ALERTING to xref=5, {1249560633.19285}.g2/4 callid=12621 lastRedirection= userData=icr.m.vd.9001
		08/06/09 14:08:15 [4168] TRACE [TAPIProvider] OnAlerting xref=5 callId=12621, alertingDevice=g2/4, callerId=1650798345, callerIdName=, calledID=1650798345 userData=icr.m.vd.9001 cause=0
	*/
	Test_Event lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid );
	CPPUNIT_ASSERT(lastEvent.m_callerId == "1650798345" );
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "1650798345" );
	CPPUNIT_ASSERT(lastEvent.m_userData == "icr.m.vd.9001" );

	/*
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Hangup
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,1
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19283
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause DATA: 19
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause-txt DATA: User alerting, no answer
	*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,1";
	ev.m_uniqueId = "1249560633.19283";
	ev.m_cause = "19";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] GetStateOfDevice {12621}=> 1650798345
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]  not found device 1650798345 with callId 12621
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   handleConnectionDisconnected {1249560633.19283} to 1650798345
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionDisconnected uniqueId=1249560633.19283, address=1650798345 cause=-5
		...
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   event minimization RULE-10: Do not send DISCONNECTED to local channels. But send it if call has no destination.
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   transferring callid and other parameters to its destination asteriskCall in the 
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]     'call walk path' currently destination call {1249560633.19284}.callid = 12621
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]     now destination call {1249560633.19284}.callid = 12621 and sourceUniqueId=''
	*/
	CPPUNIT_ASSERT( NULL == m_pxCstaProvider->GetAsteriskCall("1249560633.19283") );
	pAC = m_pxCstaProvider->GetAsteriskCall("1249560633.19284");
	CPPUNIT_ASSERT( pAC->GetSourceUniqueId() == "" );

	/*
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: event DATA: OriginateResponse
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: actionid DATA: 3298
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: response DATA: Failure
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal/n
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: context DATA: from-internal
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: exten DATA: 5858
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: reason DATA: 3
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: <null>
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: callerid DATA: 1650798345
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: calleridnum DATA: 1650798345
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: calleridname DATA: #U=icr.m.vd.9001#D#Id=12621
		...
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider] Call containsCallId(12621)
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]  Call {1249560633.19284} has cause -5
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider] ASTCstaProvider::handleConnectionFailed uniqueId=1249560633.19284, address=1650798345, cause=-5
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] ASTCallMap::GetSourceCall()
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]   SourceCall is 1249560633.19284
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] GetCIDInfoFromSourceCall(1249560633.19284)
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]   Exiting with cid/cidname/userData=1650798345//icr.m.vd.9001
		...
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] AddConnectionToCallModel {12621}=> 1650798345 => FAILED
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]  done, now CALL map has 2 items
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   event minimization RULE-4: (callerid = 1650798345) == (called = 1650798345) == (address = 1650798345)
	*/	
	ev.m_channel="Local/1650798345@from-internal/n";
	ev.m_callerIdName="#U=icr.m.vd.9001#D#Id="+ToString(myCallid);
	ev.m_reason = "3";
	m_pxCstaProvider->OnOriginateFailureEvent(ev);


	/*
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Hangup
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: WOOMERA/g2/4
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19285
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause DATA: 16
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause-txt DATA: Normal Clearing
		...
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] GetStateOfDevice {12621}=> 1650798345
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]    deviceState = FAILED
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   handleConnectionDisconnected {1249560633.19285} to g2/4 with status FAILED and cause 0
	*/
	ev.m_channel = "WOOMERA/g2/4";
	ev.m_uniqueId = "1249560633.19285";
	ev.m_cause = "16";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap] GetMonitorSetFromCallModel = 12621
		08/06/09 14:08:37 [4168] TRACE [ASTCallMap]   num_monitors = 1
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]     sending CONNCLEARED to xref=5, {1249560633.19285}.5858 callid=12621
		08/06/09 14:08:37 [4168] TRACE [TAPIProvider] OnConnectionCleared xref=5 callId=12621, releasingDevice=g2/4 cause=-5
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid );
	CPPUNIT_ASSERT(lastEvent.m_cause == -5 );

	/*
		08/06/09 14:08:37 [4168] TRACE [ASTCstaProvider]   removed uniqueId=1249560633.19285 from MAP
	*/
	CPPUNIT_ASSERT( NULL == m_pxCstaProvider->GetAsteriskCall("1249560633.19285") );


	/*
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: event DATA: Hangup
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: privilege DATA: call,all
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: channel DATA: Local/1650798345@from-internal-f1d6,2
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: uniqueid DATA: 1249560633.19284
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause DATA: 16
		08/06/09 14:08:37 [4168] TRACE0 [ASTProvider] HEADER: cause-txt DATA: Normal Clearing
	*/
	ev.m_channel = "Local/1650798345@from-internal-f1d6,2";
	ev.m_uniqueId = "1249560633.19284";
	ev.m_cause = "16";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/06/09 14:08:38 [4168] TRACE [ASTCstaProvider]   removed uniqueId=1249560633.19284 from MAP
	*/
	CPPUNIT_ASSERT( NULL == m_pxCstaProvider->GetAsteriskCall("1249560633.19284") );

	/*
		08/06/09 14:08:38 [4168] TRACE [ASTCstaProvider]     sending CALLCLEARED to xref=5, callid=12621
		08/06/09 14:08:38 [4168] TRACE [TAPIProvider] OnCallCleared xref=5 callId=12621 userData= cause=0
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETCallCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid );
	CPPUNIT_ASSERT(lastEvent.m_cause == ast_cause_alerting_noanswer );

	m_pxCstaProvider->CloseMonitor(xref);
}

void ActivaTSP_Test_Adapter::extension_to_extension_call_1251274964_5()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	Test_Event lastEvent ;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("418");

	/*
	08/26/09 10:22:40 [6028] TRACE [ASTCallMap] AddConnectionToCallModel {3, 418} => INITIALIZED

	see: originate
	So in test we need to simulate this artificially:
		callid = m_callMap.GetNewCallId();
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	DWORD	myCallid = m_pxCstaProvider->m_callMap.GetNewCallId();
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(myCallid, "418" /*callingDevice*/, INITIALIZED );

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251274964.5; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Down; ev.m_channel=Local/418@from-internal-ea62,1;
	*/
	ev.m_uniqueId="1251274964.5"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/418@from-internal-ea62,1";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251274964.6; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Ring; ev.m_channel=Local/418@from-internal-ea62,2;
	*/
	ev.m_uniqueId="1251274964.6"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/418@from-internal-ea62,2";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251274964.5; ev.m_callerId=418; ev.m_callerIdName=#Id=3;
	*/
	ev.m_uniqueId="1251274964.5"; ev.m_callerId="418"; ev.m_callerIdName="#Id="+ToString(myCallid);
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*	
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251274964.5; ev.m_callerId=418; ev.m_callerIdName=#Id=3;
	*/
	ev.m_uniqueId="1251274964.5"; ev.m_callerId="418"; ev.m_callerIdName="#Id="+ToString(myCallid);
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251274964.7; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Down; ev.m_channel=SIP/418-08276b20;
	*/
	ev.m_uniqueId="1251274964.7"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/418-08276b20";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId=1251274964.6; ev.m_destUniqueId=1251274964.7; ev.m_callerIdName=#Id=3; ev.m_callerId=418;
	*/
	ev.m_srcUniqueId="1251274964.6"; ev.m_destUniqueId="1251274964.7"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_callerId="418";
	m_pxCstaProvider->OnDialEvent(ev);
	
	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251274964.7; ev.m_callerId=418; ev.m_callerIdName=<Unknown>;
	*/
	ev.m_uniqueId="1251274964.7"; ev.m_callerId="418"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
		08/26/09 10:22:40 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274964.7; ev.m_callerIdName=<unknown>; ev.m_state=Ringing; ev.m_channel=SIP/418-08276b20;
	*/
	ev.m_uniqueId="1251274964.7"; ev.m_callerIdName="<unknown>"; ev.m_state="Ringing"; ev.m_channel="SIP/418-08276b20";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:42 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274964.7; ev.m_callerIdName=<unknown>; ev.m_state=Up; ev.m_channel=SIP/418-08276b20;
	*/
	ev.m_uniqueId="1251274964.7"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="SIP/418-08276b20";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:42 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274964.6; ev.m_callerIdName=#Id=3; ev.m_state=Up; ev.m_channel=Local/418@from-internal-ea62,2;
	*/
	ev.m_uniqueId="1251274964.6"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_state="Up"; ev.m_channel="Local/418@from-internal-ea62,2";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251274964.6; ev.m_destUniqueId=1251274964.7; 
	*/
	ev.m_srcUniqueId="1251274964.6"; ev.m_destUniqueId="1251274964.7"; 
	m_pxCstaProvider->OnLinkEvent(ev);
	
	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274964.5; ev.m_callerIdName=#Id=3; ev.m_state=Up; ev.m_channel=Local/418@from-internal-ea62,1;
	*/
	ev.m_uniqueId="1251274964.5"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_state="Up"; ev.m_channel="Local/418@from-internal-ea62,1";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251274967.8; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Down; ev.m_channel=SIP/518-08281d80;
	*/
	ev.m_uniqueId="1251274967.8"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/518-08281d80";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId=1251274964.5; ev.m_destUniqueId=1251274967.8; ev.m_callerIdName=#Id=3; ev.m_callerId=418;
	*/
	ev.m_srcUniqueId="1251274964.5"; ev.m_destUniqueId="1251274967.8"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_callerId="418";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251274967.8; ev.m_callerId=518; ev.m_callerIdName=<Unknown>;
	*/
	ev.m_uniqueId="1251274967.8"; ev.m_callerId="518"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251274964.6; ev.m_destUniqueId=1251274964.7; 
	*/
	ev.m_srcUniqueId="1251274964.6"; ev.m_destUniqueId="1251274964.7";
	m_pxCstaProvider->OnLinkEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274967.8; ev.m_callerIdName=<unknown>; ev.m_state=Ringing; ev.m_channel=SIP/518-08281d80;
	*/
	ev.m_uniqueId="1251274967.8"; ev.m_callerIdName="<unknown>"; ev.m_state="Ringing"; ev.m_channel="SIP/518-08281d80";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:43 [6320] TRACE [ASTCstaProvider]     sending ALERTING to xref=1, {1251274967.8}.518 callid=3 lastRedirection= userData=
		08/26/09 10:22:43 [6320] TRACE [TAPIProvider] OnAlerting xref=1 callId=3, alertingDevice=518, callerId=418, callerIdName=, calledID=518 userData= cause=0
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "518");
	CPPUNIT_ASSERT(lastEvent.m_callerId == "418");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "518");

	/*
		08/26/09 10:22:46 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251274967.8; ev.m_callerIdName=<unknown>; ev.m_state=Up; ev.m_channel=SIP/518-08281d80;
	*/
	ev.m_uniqueId="1251274967.8"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="SIP/518-08281d80";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
		08/26/09 10:22:46 [6320] TRACE [ASTCstaProvider]     sending ESTABLISHED to xref=1, {1251274967.8}.518 callid=3 lastRedirection= userData=
		08/26/09 10:22:46 [6320] TRACE [TAPIProvider] OnEstablished xref=1 callId=3, establishedDevice=518, callerId=418, callerIdName=, calledDevice =518, lastRedirectingDevice=, userData= cause=0
		08/26/09 10:22:46 [6320] TRACE [TAPIProvider]  searching a TapiCall with callId 3 in tapiLine 0x3ec3f48
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETEstablished);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "518");
	CPPUNIT_ASSERT(lastEvent.m_callerId == "418");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "518");

	/*
		08/26/09 10:22:46 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251274964.5; ev.m_destUniqueId=1251274967.8; 
	*/
	ev.m_srcUniqueId="1251274964.5"; ev.m_destUniqueId="1251274967.8"; 
	m_pxCstaProvider->OnLinkEvent(ev);


	/*
		08/26/09 10:22:47 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251274964.6; ev.m_destUniqueId=1251274964.7; 
	*/
	ev.m_srcUniqueId="1251274964.6"; ev.m_destUniqueId="1251274964.7"; 
	m_pxCstaProvider->OnLinkEvent(ev);
	
	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251274967.8; ev.m_cause=16; ev.m_reason=;
	*/
	ev.m_uniqueId="1251274967.8"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider]     sending CONNCLEARED to xref=1, {1251274967.8}.418 callid=3
		08/26/09 10:22:50 [6320] TRACE [TAPIProvider] OnConnectionCleared xref=1 callId=3, releasingDevice=518 cause=0

	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "518");
	CPPUNIT_ASSERT(lastEvent.m_cause == 0);

	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251274964.5; ev.m_cause=16; ev.m_reason=;
	*/
	ev.m_uniqueId="1251274964.5"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251274964.7; ev.m_cause=16; ev.m_reason=;
	*/
	ev.m_uniqueId="1251274964.7"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider]     sending CONNCLEARED to xref=1, {1251274964.7}.418 callid=3
		08/26/09 10:22:50 [6320] TRACE [TAPIProvider] OnConnectionCleared xref=1 callId=3, releasingDevice=418 cause=0
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "418");
	CPPUNIT_ASSERT(lastEvent.m_cause == 0);

	/*
		08/26/09 10:22:50 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251274964.6; ev.m_cause=16; ev.m_reason=;
	*/
	ev.m_uniqueId="1251274964.6"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	m_pxCstaProvider->CloseMonitor(xref);
}

void ActivaTSP_Test_Adapter::extension_to_isdn_call_1251279523_13()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	Test_Event lastEvent ;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("418");

	/*
	08/26/09 11:38:38 [4328] TRACE [ASTCallMap] AddConnectionToCallModel {13, 418} => INITIALIZED

	see: originate
	So in test we need to simulate this artificially:
		callid = m_callMap.GetNewCallId();
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	DWORD	myCallid = m_pxCstaProvider->m_callMap.GetNewCallId();
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(myCallid, "418" /*callingDevice*/, INITIALIZED );

	// 08/26/09 11:38:38 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251279523.13; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Down; ev.m_channel=Local/418@from-internal-a220,1;
	ev.m_uniqueId="1251279523.13"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/418@from-internal-a220,1";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	// 08/26/09 11:38:38 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251279523.14; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Ring; ev.m_channel=Local/418@from-internal-a220,2;
	ev.m_uniqueId="1251279523.14"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/418@from-internal-a220,2";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	// 08/26/09 11:38:38 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251279523.13; ev.m_callerId=418; ev.m_callerIdName=#Id=13;
	ev.m_uniqueId="1251279523.13"; ev.m_callerId="418"; ev.m_callerIdName="#Id="+ToString(myCallid);
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	// 08/26/09 11:38:38 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251279523.13; ev.m_callerId=418; ev.m_callerIdName=#Id=13;
	ev.m_uniqueId="1251279523.13"; ev.m_callerId="418"; ev.m_callerIdName="#Id="+ToString(myCallid);
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	// 08/26/09 11:38:39 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251279523.15; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Down; ev.m_channel=SIP/418-082728d0;
	ev.m_uniqueId="1251279523.15"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/418-082728d0";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	// 08/26/09 11:38:39 [6320] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId=1251279523.14; ev.m_destUniqueId=1251279523.15; ev.m_callerIdName=#Id=13; ev.m_callerId=418;
	ev.m_srcUniqueId="1251279523.14"; ev.m_destUniqueId="1251279523.15"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_callerId="418";
	m_pxCstaProvider->OnDialEvent(ev);

	// 08/26/09 11:38:39 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1251279523.15"; ev.m_callerId=418; ev.m_callerIdName=<Unknown>;
	ev.m_uniqueId="1251279523.15"; ev.m_callerId="418"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	// 08/26/09 11:38:39 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279523.15; ev.m_callerIdName=<unknown>; ev.m_state=Ringing; ev.m_channel=SIP/418-082728d0;
	ev.m_uniqueId="1251279523.15"; ev.m_callerIdName="<unknown>"; ev.m_state="Ringing"; ev.m_channel="SIP/418-082728d0";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:40 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279523.15; ev.m_callerIdName=<unknown>; ev.m_state=Up; ev.m_channel=SIP/418-082728d0;
	ev.m_uniqueId="1251279523.15"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="SIP/418-082728d0";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:40 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279523.14; ev.m_callerIdName=#Id=13; ev.m_state=Up; ev.m_channel=Local/418@from-internal-a220,2;
	ev.m_uniqueId="1251279523.14"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_state="Up"; ev.m_channel="Local/418@from-internal-a220,2";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:40 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251279523.14; ev.m_destUniqueId=1251279523.15; 
	ev.m_srcUniqueId="1251279523.14"; ev.m_destUniqueId="1251279523.15"; 
	m_pxCstaProvider->OnLinkEvent(ev);

	// 08/26/09 11:38:40 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279523.13; ev.m_callerIdName=#Id=13; ev.m_state=Up; ev.m_channel=Local/418@from-internal-a220,1;
	ev.m_uniqueId="1251279523.13"; ev.m_callerIdName="#Id="+ToString(myCallid); ev.m_state="Up"; ev.m_channel="Local/418@from-internal-a220,1";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251279523.13; ev.m_callerId=932289310; ev.m_callerIdName=<Unknown>;
	ev.m_uniqueId="1251279523.13"; ev.m_callerId="932289310"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId=1251279525.16; ev.m_callerId=<unknown>; ev.m_callerIdName=<unknown>; ev.m_state=Rsrvd; ev.m_channel=mISDN/0-u8;
	ev.m_uniqueId="1251279525.16"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Rsrvd"; ev.m_channel="mISDN/0-u8";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279525.16; ev.m_callerIdName=<unknown>; ev.m_state=Dialing; ev.m_channel=mISDN/0-u8;
	ev.m_uniqueId="1251279525.16"; ev.m_callerIdName="<unknown>"; ev.m_state="Dialing"; ev.m_channel="mISDN/0-u8";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId=1251279523.13; ev.m_destUniqueId=1251279525.16; ev.m_callerIdName=<unknown>; ev.m_callerId=932289310;
	ev.m_srcUniqueId="1251279523.13"; ev.m_destUniqueId="1251279525.16"; ev.m_callerIdName="<unknown>"; ev.m_callerId="932289310";
	m_pxCstaProvider->OnDialEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId=1251279525.16; ev.m_callerId=0629709066; ev.m_callerIdName=<Unknown>;
	ev.m_uniqueId="1251279525.16"; ev.m_callerId="0629709066"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	// 08/26/09 11:38:41 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251279523.14; ev.m_destUniqueId=1251279523.15; 
	ev.m_srcUniqueId="1251279523.14"; ev.m_destUniqueId="1251279523.15"; 
	m_pxCstaProvider->OnLinkEvent(ev);

	// 08/26/09 11:38:44 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279525.16; ev.m_callerIdName=<unknown>; ev.m_state=Ringing; ev.m_channel=mISDN/1-u11;
	ev.m_uniqueId="1251279525.16"; ev.m_callerIdName="<unknown>"; ev.m_state="Ringing"; ev.m_channel="mISDN/1-u11";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:44 [6320] TRACE [ASTCstaProvider]     sending ALERTING to xref=1, {1251279525.16}.misdn/0-u8 callid=13 lastRedirection= userData=
	// 08/26/09 11:38:44 [6320] TRACE [TAPIProvider] OnAlerting xref=1 callId=13, alertingDevice=misdn/0-u8, callerId=932289310, callerIdName=<unknown>, calledID=0629709066 userData= cause=0
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_callerId == "932289310");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "0629709066");
	CPPUNIT_ASSERT(lastEvent.m_cause == 0);


	// 08/26/09 11:38:44 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251279523.14; ev.m_destUniqueId=1251279523.15; 
	ev.m_srcUniqueId="1251279523.14"; ev.m_destUniqueId="1251279523.15"; 
	m_pxCstaProvider->OnLinkEvent(ev);

	// 08/26/09 11:38:47 [6320] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId=1251279525.16; ev.m_callerIdName=<unknown>; ev.m_state=Up; ev.m_channel=mISDN/1-u11;
	ev.m_uniqueId="1251279525.16"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="mISDN/1-u11";
	m_pxCstaProvider->OnNewStateEvent(ev);

	// 08/26/09 11:38:47 [6320] TRACE [ASTCstaProvider]     sending ESTABLISHED to xref=1, {1251279525.16}.misdn/0-u8 callid=13 lastRedirection= userData=
	// 08/26/09 11:38:47 [6320] TRACE [TAPIProvider] OnEstablished xref=1 callId=13, establishedDevice=misdn/0-u8, callerId=932289310, callerIdName=<unknown>, calledDevice =0629709066, lastRedirectingDevice=, userData= cause=0
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETEstablished);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_callerId == "932289310");
	CPPUNIT_ASSERT(lastEvent.m_calledDevice == "0629709066");
	CPPUNIT_ASSERT(lastEvent.m_cause == 0);

	// 08/26/09 11:38:47 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251279523.13; ev.m_destUniqueId=1251279525.16; 
	ev.m_srcUniqueId="1251279523.13"; ev.m_destUniqueId="1251279525.16"; 
	m_pxCstaProvider->OnLinkEvent(ev);

	// 08/26/09 11:38:47 [6320] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId=1251279523.14; ev.m_destUniqueId=1251279523.15; 
	ev.m_srcUniqueId="1251279523.14"; ev.m_destUniqueId="1251279523.15"; 
	m_pxCstaProvider->OnLinkEvent(ev);

	// 08/26/09 11:38:51 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251279523.15; ev.m_cause=16; ev.m_reason=;
	ev.m_uniqueId="1251279523.15"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	// 08/26/09 11:38:51 [6320] TRACE [ASTCstaProvider]     sending CONNCLEARED to xref=1, {1251279523.15}.418 callid=13
	// 08/26/09 11:38:51 [6320] TRACE [TAPIProvider] OnConnectionCleared xref=1 callId=13, releasingDevice=418 cause=0
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "418");

	// 08/26/09 11:38:51 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251279523.14; ev.m_cause=16; ev.m_reason=;
	ev.m_uniqueId="1251279523.14"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	// 08/26/09 11:38:51 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251279525.16; ev.m_cause=16; ev.m_reason=;
	ev.m_uniqueId="1251279525.16"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	// 08/26/09 11:38:51 [6320] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId=1251279523.13; ev.m_cause=16; ev.m_reason=;
	ev.m_uniqueId="1251279523.13"; ev.m_cause="16"; ev.m_reason="";
	m_pxCstaProvider->OnHangup(ev);

	m_pxCstaProvider->CloseMonitor(xref);
}

void ActivaTSP_Test_Adapter::predictive_call_no_answer_on_iax()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	Test_Event lastEvent ;
	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("101");

	/*
	12/04/09 16:51:13 [5916] TRACE [ASTCallMap] AddConnectionToCallModel {52863, 101} => INITIALIZED

	see: originate
	So in test we need to simulate this artificially:
		callid = m_callMap.GetNewCallId();
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	DWORD	myCallid = m_pxCstaProvider->m_callMap.GetNewCallId();
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(myCallid, "101" /*callingDevice*/, INITIALIZED );

	/*
	12/04/09 16:51:13 [5740] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1259967403.519598"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/417138583966@from-internal-44ba,1"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519598"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/417138583966@from-internal-44ba,1"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	12/04/09 16:51:13 [5740] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1259967403.519599"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/417138583966@from-internal-44ba,2"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519599"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/417138583966@from-internal-44ba,2"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	12/04/09 16:51:13 [5740] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1259967403.519598"; ev.m_callerId="417138583966"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id=52863"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519598"; ev.m_callerId="417138583966"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id="+ToString(myCallid); //idcall52863"; 
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	12/04/09 16:51:13 [5740] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1259967403.519598"; ev.m_callerId="417138583966"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id=52863"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519598"; ev.m_callerId="417138583966"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id="+ToString(myCallid); //52863"; 
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1259967403.519604"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="IAX2/dnetworks_new_iax-7642"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519604"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="IAX2/dnetworks_new_iax-7642"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1259967403.519604"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id=52863"; ev.m_state="Ringing"; ev.m_channel="IAX2/dnetworks_new_iax-7642"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519604"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id="+ToString(myCallid); ev.m_state="Ringing"; ev.m_channel="IAX2/dnetworks_new_iax-7642"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider]     sending event:CFTE:ALERTING to xref=481, address=dnetworks_new_iax, callid=52863, lastRedirection=, userData=
	*/
	/***** regression: revision 493 regression did not send this ***/
	/*lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "dnetworks_new_iax");*/

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId="1259967403.519599"; ev.m_destUniqueId="1259967403.519604"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id=52863"; ev.m_callerId="417138583966"; m_pxCstaProvider->OnDialEvent(ev);
	*/
	ev.m_srcUniqueId="1259967403.519599"; ev.m_destUniqueId="1259967403.519604"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id="+ToString(myCallid); ev.m_callerId="417138583966"; 
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider]     sending event:CFTE:ALERTING to xref=481, address=dnetworks_new_iax, callid=52863, lastRedirection=, userData=icr.m.vd.00005
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "dnetworks_new_iax");

	/*
	12/04/09 16:51:14 [5740] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1259967403.519604"; ev.m_callerId="417138583966"; ev.m_callerIdName="<Unknown>"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519604"; ev.m_callerId="417138583966"; ev.m_callerIdName="<Unknown>"; 
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1259967403.519598"; ev.m_cause="19"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519598"; ev.m_cause="19"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1259967403.519604"; ev.m_cause="0"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519604"; ev.m_cause="0"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider]     sending event:CFTE:CONNCLEARED to xref=481, address=101, callid=52863
	/// BUG: 12/04/09 16:51:38 [5740] TRACE [TAPIProvider]   LINEDISCONNECTMODE_UNKNOWN htapicall=0x10496
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETConnCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice == "dnetworks_new_iax");
/////	CPPUNIT_ASSERT(lastEvent.m_cause == 0);		/// cause =0 ?  or cause = 19?


	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider] OnOriginateFailureEvent:CFT: ev.m_channel="Local/417138583966@from-internal/n"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id=52863"; ev.m_reason="3"; m_pxCstaProvider->OnOriginateFailureEvent(ev);
	*/
	ev.m_channel="Local/417138583966@from-internal/n"; ev.m_callerIdName="#U=icr.m.vd.00005#D#Id="+ToString(myCallid); ev.m_reason="3"; 
	m_pxCstaProvider->OnOriginateFailureEvent(ev);

	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1259967403.519599"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1259967403.519599"; ev.m_cause="16"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	12/04/09 16:51:38 [5740] TRACE [ASTCstaProvider]     sending event:CFTE:CALLCLEARED to xref=481, callid=52863
	*/
	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETCallCleared);
	CPPUNIT_ASSERT(lastEvent.m_callId == myCallid);
	CPPUNIT_ASSERT(lastEvent.m_cause == ast_cause_alerting_noanswer);		/// cause =0 ?  or cause = 19?

	m_pxCstaProvider->CloseMonitor(xref);
}

void ActivaTSP_Test_Adapter::predictive_call_no_answer_on_sip_without_newstate()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	DWORD			callid=235112;
	std::string		callerId="tocoltocult";
	Test_Event		lastEvent ;

	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("5000");

	/*
	02/04/10 17:17:17 [4824] TRACE [ASTCallMap] AddConnectionToCallModel {235112, 5000} => INITIALIZED

	see: originate
	So in test we need to simulate this artificially:
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(callid, "5000" /*callingDevice*/, INITIALIZED );

	/*
		02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1265300274.47655"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/0680914949@from-internal-0325,1"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47655"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/0680914949@from-internal-0325,1"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);
	
	/*
		02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1265300274.47656"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/0680914949@from-internal-0325,2"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47656"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/0680914949@from-internal-0325,2"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
		02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1265300274.47655"; ev.m_callerId="0680914949"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47655"; ev.m_callerId="0680914949"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; 
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
		02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1265300274.47655"; ev.m_callerId="0680914949"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47655"; ev.m_callerId="0680914949"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; 
	m_pxCstaProvider->OnNewCallerIdEvent(ev);
	
	/*
		02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1265300274.47656"; ev.m_callerId="<Unknown>"; ev.m_callerIdName="hidden"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47656"; ev.m_callerId="<Unknown>"; ev.m_callerIdName="hidden";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1265300274.47657"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/ToColtOcult-c4381810"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47657"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/ToColtOcult-c4381810";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId="1265300274.47656"; ev.m_destUniqueId="1265300274.47657"; ev.m_callerIdName="hidden"; ev.m_callerId="<unknown>"; m_pxCstaProvider->OnDialEvent(ev);
	*/
	ev.m_srcUniqueId="1265300274.47656"; ev.m_destUniqueId="1265300274.47657"; ev.m_callerIdName="hidden"; ev.m_callerId="<unknown>"; 
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	02/04/10 17:17:17 [4512] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1265300274.47657"; ev.m_callerId="0680914949"; ev.m_callerIdName="<Unknown>"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47657"; ev.m_callerId="0680914949"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	02/04/10 17:17:32 [4512] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1265300274.47655"; ev.m_cause="0"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47655"; ev.m_cause="0"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	02/04/10 17:17:32 [4512] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1265300274.47657"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47657"; ev.m_cause="16";
	m_pxCstaProvider->OnHangup(ev);

	//ACTIVA_TEST_EVENT_CONNCLEARED(m_pxCstaListener,callid,callerId,ast_cause_alerting_noanswer);

	/*
	02/04/10 17:17:32 [4512] TRACE [ASTCstaProvider] OnOriginateFailureEvent:CFT: ev.m_channel="Local/0680914949@from-internal/n"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; ev.m_reason="0"; m_pxCstaProvider->OnOriginateFailureEvent(ev);
	*/
	ev.m_channel="Local/0680914949@from-internal/n"; ev.m_callerIdName="#U=icr.m.vd.9001#D#Id=235112"; ev.m_reason="0"; 
	m_pxCstaProvider->OnOriginateFailureEvent(ev);


	//Forcing the hangup in the h extension of the dialplan Hangup (19) with cause alerting no answer, you can use DIA. Call cleared event will send the correct cause to TAPI. 
	/*
	02/04/10 17:17:32 [4512] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1265300274.47656"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1265300274.47656"; ev.m_cause="19"; 
	m_pxCstaProvider->OnHangup(ev);

	ACTIVA_TEST_EVENT_CALLCLEARED(m_pxCstaListener,callid,ast_cause_alerting_noanswer);

	m_pxCstaProvider->CloseMonitor(xref);

}

void ActivaTSP_Test_Adapter::predictive_call_two_alerting_event_on_sip_newstateRinging_Dial_secuence()
{
	ManagerEvent	ev;
	AsteriskCall	*pAC = NULL;
	DWORD			callid=4605;
	std::string		callerId="tocoltocult";
	Test_Event		lastEvent ;

	m_pxCstaListener->m_xEvents.clear();
	int	xref = m_pxCstaProvider->OpenMonitor("105");
	int	xref2 = m_pxCstaProvider->OpenMonitor("225");

	/*
	02/04/10 17:17:17 [4824] TRACE [ASTCallMap] AddConnectionToCallModel {235112, 5000} => INITIALIZED

	see: originate
	So in test we need to simulate this artificially:
		m_callMap.AddConnectionToCallModel(callid, callingDevice, INITIALIZED );
	*/
	m_pxCstaProvider->m_callMap.AddConnectionToCallModel(callid, "105" /*callingDevice*/, INITIALIZED );
	
	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/0575772924@from-internal-47d3,1"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="Local/0575772924@from-internal-47d3,1";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1273666579.3762"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/0575772924@from-internal-47d3,2"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3762"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/0575772924@from-internal-47d3,2";
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1273666579.3763"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3763"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666579.3763"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Ringing"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3763"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Ringing"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId="1273666579.3762"; ev.m_destUniqueId="1273666579.3763"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_callerId="0575772924"; m_pxCstaProvider->OnDialEvent(ev);
	*/
	ev.m_srcUniqueId="1273666579.3762"; ev.m_destUniqueId="1273666579.3763"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_callerId="0575772924";
	m_pxCstaProvider->OnDialEvent(ev);

	/*
	05/12/10 16:16:23 [1380] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1273666579.3763"; ev.m_callerId="0575772924"; ev.m_callerIdName="<Unknown>"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3763"; ev.m_callerId="0575772924"; ev.m_callerIdName="<Unknown>";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);

	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666579.3763"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3763"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="IAX2/192.168.0.150:4569-15191"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/0575772924@from-internal-47d3,1"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/0575772924@from-internal-47d3,1";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnNewCallerIdEvent:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; m_pxCstaProvider->OnNewCallerIdEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_callerId="0575772924"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605";
	m_pxCstaProvider->OnNewCallerIdEvent(ev);
	
	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnJoinEvent:CFT: ev.m_channel="Local/0575772924@from-internal-47d3,1"; ev.m_queue="105"; ev.m_position="2"; ev.m_count="2"; m_pxCstaProvider->OnJoinEvent(ev);
	*/
	ev.m_channel="Local/0575772924@from-internal-47d3,1"; ev.m_queue="105"; ev.m_position="2"; ev.m_count="2";
	m_pxCstaProvider->OnJoinEvent(ev);

	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666579.3762"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/0575772924@from-internal-47d3,2"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3762"; ev.m_callerIdName="#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/0575772924@from-internal-47d3,2";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:25 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3833"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Busy"; ev.m_channel="Local/227@from-internal-c565,2"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	//ev.m_uniqueId="1273666581.3833"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Busy"; ev.m_channel="Local/227@from-internal-c565,2";
	//m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:26 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3847"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Busy"; ev.m_channel="Local/226@from-internal-5475,2"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	//ev.m_uniqueId="1273666581.3847"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Busy"; ev.m_channel="Local/226@from-internal-5475,2"; 
	//m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:26 [1380] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1273666581.3859"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/225@from-internal-5dff,2"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3859"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Ring"; ev.m_channel="Local/225@from-internal-5dff,2";
	m_pxCstaProvider->OnNewChannelEvent(ev);


	/*
	05/12/10 16:16:26 [1380] TRACE [ASTCstaProvider] OnNewChannelEvent:CFT: ev.m_uniqueId="1273666581.3867"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/225-082590f0"; m_pxCstaProvider->OnNewChannelEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3867"; ev.m_callerId="<unknown>"; ev.m_callerIdName="<unknown>"; ev.m_state="Down"; ev.m_channel="SIP/225-082590f0"; 
	m_pxCstaProvider->OnNewChannelEvent(ev);

	/*
	05/12/10 16:16:26 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3867"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Ringing"; ev.m_channel="SIP/225-082590f0"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3867"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Ringing"; ev.m_channel="SIP/225-082590f0"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:26 [1380] TRACE [ASTCstaProvider] OnDialEvent:CFT: ev.m_srcUniqueId="1273666581.3859"; ev.m_destUniqueId="1273666581.3867"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_callerId="0575772924"; m_pxCstaProvider->OnDialEvent(ev);
	*/
	ev.m_srcUniqueId="1273666581.3859"; ev.m_destUniqueId="1273666581.3867"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_callerId="0575772924"; 
	m_pxCstaProvider->OnDialEvent(ev);

	lastEvent = m_pxCstaListener->m_xEvents.front();// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType == eETAlerting);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice=="225");
	//CPPUNIT_ASSERT(lastEvent.m_calledDevice=="105");

	//Test if an repeated alerting is send
	Test_Event lastLastEvent = m_pxCstaListener->m_xEvents[m_pxCstaListener->m_xEvents.size()-2];// same as m_xEvents[0];
	CPPUNIT_ASSERT(lastEvent.m_eEventType!=lastLastEvent.m_eEventType);
	CPPUNIT_ASSERT(lastEvent.m_subjectDevice!=lastLastEvent.m_subjectDevice);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3867"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="SIP/225-082590f0"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3867"; ev.m_callerIdName="<unknown>"; ev.m_state="Up"; ev.m_channel="SIP/225-082590f0"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3859"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/225@from-internal-5dff,2"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3859"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/225@from-internal-5dff,2"; 
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId="1273666581.3859"; ev.m_destUniqueId="1273666581.3867"; m_pxCstaProvider->OnLinkEvent(ev);
	*/
	ev.m_srcUniqueId="1273666581.3859"; ev.m_destUniqueId="1273666581.3867";
	m_pxCstaProvider->OnLinkEvent(ev);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnNewStateEvent:CFT: ev.m_uniqueId="1273666581.3858"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/225@from-internal-5dff,1"; m_pxCstaProvider->OnNewStateEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3858"; ev.m_callerIdName="105:#U=icr.m.vd.00004#D#Id=4605"; ev.m_state="Up"; ev.m_channel="Local/225@from-internal-5dff,1";
	m_pxCstaProvider->OnNewStateEvent(ev);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnLeaveEvent:CFT: ev.m_channel="Local/0575772924@from-internal-47d3,1"; ev.m_queue="105"; m_pxCstaProvider->OnLeaveEvent(ev);
	*/
	ev.m_channel="Local/0575772924@from-internal-47d3,1"; 
	ev.m_queue="105"; m_pxCstaProvider->OnLeaveEvent(ev);

	/*
	05/12/10 16:16:28 [1380] TRACE [ASTCstaProvider] OnLinkEvent:CFT: ev.m_srcUniqueId="1273666579.3761"; ev.m_destUniqueId="1273666581.3858"; m_pxCstaProvider->OnLinkEvent(ev);
	*/
	ev.m_srcUniqueId="1273666579.3761"; ev.m_destUniqueId="1273666581.3858";
	m_pxCstaProvider->OnLinkEvent(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666581.3858"; ev.m_cause="0"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3858"; ev.m_cause="0"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666579.3761"; ev.m_cause="0"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3761"; ev.m_cause="0";
	m_pxCstaProvider->OnHangup(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666581.3867"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3867"; ev.m_cause="16"; 
	m_pxCstaProvider->OnHangup(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666581.3859"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666581.3859"; ev.m_cause="16";
	m_pxCstaProvider->OnHangup(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666579.3763"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3763"; ev.m_cause="16";
	m_pxCstaProvider->OnHangup(ev);

	/*
	05/12/10 16:16:39 [1380] TRACE [ASTCstaProvider] OnHangup:CFT: ev.m_uniqueId="1273666579.3762"; ev.m_cause="16"; m_pxCstaProvider->OnHangupEvent(ev);
	*/
	ev.m_uniqueId="1273666579.3762"; ev.m_cause="16"; 
	m_pxCstaProvider->OnHangup(ev);

	m_pxCstaProvider->CloseMonitor(xref);

}

#endif	//	__ACTIVATSP_CPPUNIT_BUILD
