#pragma once

#ifdef	__ACTIVATSP_CPPUNIT_BUILD

#ifndef ACTIVATSP_TEST_ADAPTER_H
#define ACTIVATSP_TEST_ADAPTER_H

#include <cppunit/extensions/HelperMacros.h>
#include "..\ASTProvider\src\astcstaprovider.h"
#include <vector>

#define ACTIVA_TEST_EVENT(pxCstaListener,eEventType,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)     \
	{																																	\
	CPPUNIT_ASSERT_MESSAGE("We are trying to access a Test_Event than wasn't produced!",m_pxCstaListener->m_xEvents.size()>0);	\
	char c[256];std::string m(""),t("");\
	Test_Event last_Event=m_pxCstaListener->m_xEvents.front();											\
							sprintf_s(c,"Event %s DUMP:\n",#eEventType);m+=c;\
							sprintf_s(c,"\tlast_Event.m_callId=%d ,expected %d\n"				,last_Event.m_callId,callId);m+=c;\
	t=subjectDevice;		sprintf_s(c,"\tlast_Event.m_subjectDevice=%s ,expected %s\n"			,last_Event.m_subjectDevice.c_str(),t.c_str());m+=c;\
	t=callerId;				sprintf_s(c,"\tlast_Event.m_callerId=%s ,expected %s\n"				,last_Event.m_callerId.c_str(),t.c_str());m+=c;\
	t=callerIdName;			sprintf_s(c,"\tlast_Event.m_callerIdName=%s ,expected %s\n"			,last_Event.m_callerIdName.c_str(),t.c_str());m+=c;\
	t=calledDevice;			sprintf_s(c,"\tlast_Event.m_calledDevice=%s ,expected %s\n"			,last_Event.m_calledDevice.c_str(),t.c_str());m+=c;\
	t=userData;				sprintf_s(c,"\tlast_Event.m_userData=%s ,expected %s\n"			,last_Event.m_userData.c_str(),t.c_str());m+=c;\
							sprintf_s(c,"\tlast_Event.m_cause=%d ,expected %d\n"				,last_Event.m_cause,cause);m+=c;\
	CPPUNIT_ASSERT_MESSAGE("1.-"+m,last_Event.m_eEventType==eEventType);			\
	CPPUNIT_ASSERT_MESSAGE("2.-"+m,last_Event.m_callId==callId);					\
	CPPUNIT_ASSERT_MESSAGE("3.-"+m,last_Event.m_subjectDevice==subjectDevice);		\
	CPPUNIT_ASSERT_MESSAGE("4.-"+m,last_Event.m_callerId==callerId);				\
	CPPUNIT_ASSERT_MESSAGE("5.-"+m,last_Event.m_callerIdName==callerIdName);		\
	CPPUNIT_ASSERT_MESSAGE("6.-"+m,last_Event.m_calledDevice==calledDevice);		\
	CPPUNIT_ASSERT_MESSAGE("7.-"+m,last_Event.m_userData==userData);				\
	CPPUNIT_ASSERT_MESSAGE("8.-"+m,last_Event.m_cause==cause);					\
	}

//Originated
#define ACTIVA_TEST_EVENT_ORIGINATED(pxCstaListener,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)       \
	ACTIVA_TEST_EVENT(pxCstaListener,eETOriginated,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)
//Alerting
#define ACTIVA_TEST_EVENT_ALERTING(pxCstaListener,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)       \
	ACTIVA_TEST_EVENT(pxCstaListener,eETAlerting,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)
//Established
#define ACTIVA_TEST_EVENT_ESTABLISHED(pxCstaListener,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)	\
	ACTIVA_TEST_EVENT(pxCstaListener,eETEstablished,callId,subjectDevice,callerId,callerIdName,calledDevice,userData,cause)
//ConneCleared
#define ACTIVA_TEST_EVENT_CONNCLEARED(pxCstaListener,callId,releasingDevice,cause)	\
	ACTIVA_TEST_EVENT(pxCstaListener,eETConnCleared,callId,releasingDevice,"","","","",cause)
//Queued
#define ACTIVA_TEST_EVENT_QUEUED(pxCstaListener,callId,queuedDevice, callerId, callerIdName, calledDevice, userData, cause)	\
	ACTIVA_TEST_EVENT(pxCstaListener,eETQueued,callId,queuedDevice, callerId, callerIdName, calledDevice, userData, cause)
//Diverted
#define ACTIVA_TEST_EVENT_DIVERTED(pxCstaListener,callId,divertedDevice,callerId,callerIdName,calledDevice,userData,cause)	\
	ACTIVA_TEST_EVENT(pxCstaListener,eETDiverted,callId,divertedDevice,callerId,callerIdName,calledDevice,userData,cause)
//CallCleared
#define ACTIVA_TEST_EVENT_CALLCLEARED(pxCstaListener,callId,cause)	\
	ACTIVA_TEST_EVENT(pxCstaListener,eETCallCleared,callId,"","","","","",cause)


#define ACTIVA_TEST_CALLMAP_CALL(pxCstaProvider,callUniqueid,callId,address,numDevice,callerId,callerIdName,channel,state,userData,sourceUniqueId,lastRedirectionDevice,bIsPredictiveCall,cause)\
	{																																	\
	ACTIVA_TEST_CALLMAP_CALL18(pxCstaProvider,callUniqueid,callId,address,numDevice,callerId,callerIdName,"","",channel,state,userData,sourceUniqueId,lastRedirectionDevice,bIsPredictiveCall,cause)\
	}

#define ACTIVA_TEST_CALLMAP_CALL18(pxCstaProvider,callUniqueid,callId,address,numDevice,callerId,callerIdName,connectedLineNum,connectedLineName,channel,state,userData,sourceUniqueId,lastRedirectionDevice,bIsPredictiveCall,cause)\
	{																																	\
	AsteriskCall *astCall= pxCstaProvider->GetAsteriskCall(callUniqueid);									\
	char c[256];std::string m(""),t("");\
	CPPUNIT_ASSERT_MESSAGE("We are trying to access an AsteriskCall that don't exists",astCall!=NULL);	\
	t=callUniqueid;			sprintf_s(c,"Call with uniqueid = %s DUMP:\n",t.c_str());m+=c;\
	t=callUniqueid;			sprintf_s(c,"\tastCall->GetUniqueId()=%s ,expected %s\n"				,astCall->GetUniqueId().c_str(),t.c_str());m+=c;\
							sprintf_s(c,"\tastCall->GetCallId()=%d ,expected %d\n"					,astCall->GetCallId(),callId);m+=c;\
    t=address;				sprintf_s(c,"\tastCall->GetAddress()=%s ,expected %s\n"					,astCall->GetAddress().c_str(),t.c_str());m+=c;\
	t=numDevice;			sprintf_s(c,"\tastCall->GetNumDevice()=%s ,expected %s\n"				,astCall->GetNumDevice().c_str(),t.c_str());m+=c;\
	t=callerId;				sprintf_s(c,"\tastCall->GetCallerId()=%s ,expected %s\n"				,astCall->GetCallerId().c_str(),t.c_str());m+=c;\
	t=callerIdName;			sprintf_s(c,"\tastCall->GetCallerIdName()=%s ,expected %s\n"			,astCall->GetCallerIdName().c_str(),t.c_str());m+=c;\
	t=connectedLineNum;		sprintf_s(c,"\tastCall->GetConnectedLineNum()=%s ,expected %s\n"		,astCall->GetConnectedLineNum().c_str(),t.c_str());m+=c;\
	t=connectedLineName;	sprintf_s(c,"\tastCall->GetConnectedLineName()=%s ,expected %s\n"		,astCall->GetConnectedLineName().c_str(),t.c_str());m+=c;\
	t=channel;				sprintf_s(c,"\tastCall->GetChannel()=%s ,expected %s\n"					,astCall->GetChannel().c_str(),t.c_str());m+=c;\
							sprintf_s(c,"\tastCall->GetState()=%d ,expected %d\n"					,astCall->GetState(),state);m+=c;\
	t=userData;				sprintf_s(c,"\tastCall->GetUserData()=%s ,expected %s\n"				,astCall->GetUserData().c_str(),t.c_str());m+=c;\
	t=sourceUniqueId;		sprintf_s(c,"\tastCall->GetSourceUniqueId()=%s ,expected %s\n"			,astCall->GetSourceUniqueId().c_str(),t.c_str());m+=c;\
	t=lastRedirectionDevice;sprintf_s(c,"\tastCall->GetLastRedirectionDevice()=%s ,expected %s\n"	,astCall->GetLastRedirectionDevice().c_str(),t.c_str());m+=c;\
							sprintf_s(c,"\tastCall->IsPredictiveCall()=%s ,expected %s\n"			,astCall->IsPredictiveCall()?"true":"false",bIsPredictiveCall?"true":"false");m+=c;\
							sprintf_s(c,"\tastCall->GetCause()=%d ,expected %d\n"					,astCall->GetCause(),cause);m+=c;\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetUniqueId() == callUniqueid );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetCallId() == callId );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetAddress() == address );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetNumDevice() == numDevice );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetCallerId() == callerId );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetCallerIdName() == callerIdName );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetConnectedLineNum() == connectedLineNum );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetConnectedLineName() == connectedLineName );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetChannel() == channel );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetState() == state );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetUserData() == userData );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetSourceUniqueId() == sourceUniqueId );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetLastRedirectionDevice() == lastRedirectionDevice );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->IsPredictiveCall() == bIsPredictiveCall );					\
	CPPUNIT_ASSERT_MESSAGE(m,astCall->GetCause() == cause );					\
	}

#define ACTIVA_TEST_CSTA_DEVICE_STATE(pxCstaProvider,callid,deviceId,deviceState)     \
	{\
	char m[256];sprintf_s(m,"Incorrect State: pxCstaProvider->GetCSTAStateOfDeviceInCallMap(%d,%s)=%d , expected %d\n",callid,deviceId.c_str(),pxCstaProvider->GetCSTAStateOfDeviceInCallMap(callid,deviceId),deviceState);\
	CPPUNIT_ASSERT_MESSAGE(m,pxCstaProvider->GetCSTAStateOfDeviceInCallMap(callid,deviceId)==deviceState);					\
	}

enum eTestEventType {
		eETNull = 0,
		eETOriginated = 1,
		eETAlerting = 2,
		eETEstablished = 3,
		eETFailed = 4,
		eETQueued = 5,
		eETDiverted = 6,
		eETCallCleared = 7,
		eETConnCleared = 8,
		eETHeld = 9,
		eETRetrieved = 10
} ; 

class	Test_Event {
public:
	eTestEventType	m_eEventType;
	DWORD			m_callId;
	std::string		m_subjectDevice;
	std::string		m_callerId;
	std::string		m_callerIdName;
	std::string		m_calledDevice;
	std::string		m_userData;
	call_cause		m_cause;

	//ctor.
	Test_Event() {
		m_eEventType=eETNull;
		m_callId = 0;
		m_subjectDevice = "";
		m_callerId = "";
		m_callerIdName = "";
		m_calledDevice = "";
		m_userData = "";
		m_cause = ast_cause_normal;
	};
	Test_Event(eTestEventType eEventType, DWORD callId, std::string subjectDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string userData, call_cause cause) {
		m_eEventType=eEventType;
		m_callId = callId;
		m_subjectDevice = subjectDevice;
		m_callerId = callerId;
		m_callerIdName = callerIdName;
		m_calledDevice = calledDevice;
		m_userData = userData;
		m_cause = cause;
	};

	bool CompreEvent(eTestEventType eEventType, DWORD callId, std::string subjectDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string userData, call_cause cause) {
		return (m_eEventType==eEventType && m_callId==callId &&	m_subjectDevice==subjectDevice && m_callerId==callerId && 
			m_callerIdName==callerIdName && m_calledDevice==calledDevice && m_userData==userData &&	m_cause==cause);
	};
};

typedef	std::vector<Test_Event> Set_Test_Event ;	//< set of Test_Events

/// Logger interface: any customized logger must implement this interface
class ASTDummyLogListener	: public ASTLogListener {
public:
	virtual void	LogTrace0(const std::string & sOrigin, const std::string & sMsg){;};
	virtual void	LogTrace(const std::string & sOrigin, const std::string & sMsg){;};
	virtual void	LogInfo(const std::string & sOrigin, const std::string & sMsg){;};
	virtual void	LogWarn(const std::string & sOrigin, const std::string & sMsg){;};
	virtual void	LogError(const std::string & sOrigin, const std::string & sMsg){;};
};

class	Test_ASTCstaListener : public ASTCstaListener {
public:
	Set_Test_Event	m_xEvents;

	/// a call with callId has been originated at originatingDevice
	virtual void	OnOriginated ( MonitorXref xref, DWORD callId, std::string originatingDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string userData, call_cause cause) 
	{ Test_Event xEvent(eETOriginated, callId, originatingDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};
	
	/// a call with callId is alerting at alertingDevice
	virtual void	OnAlerting ( MonitorXref xref, DWORD callId, std::string alertingDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string lastRedirectingDevice, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETAlerting, callId, alertingDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId has been established at establishedDevice
	virtual void	OnEstablished ( MonitorXref xref, DWORD callId, std::string establishedDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string lastRedirectingDevice, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETEstablished, callId, establishedDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId has been failed at failingDevice
	virtual void	OnFailed ( MonitorXref xref, DWORD callId, std::string failingDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string lastRedirectionDevice, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETFailed, callId, failingDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId has been queued at queue
	virtual void	OnQueued ( MonitorXref xref, DWORD callId, std::string queuedDevice, std::string queue, int position_in_queue, int queue_len, std::string callerId, std::string callerIdName, std::string calledDevice, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETQueued, callId, queuedDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId has been diverted from a device (example: from a queue)
	virtual void	OnDiverted ( MonitorXref xref, DWORD callId, std::string divertedDevice, std::string divertingDevice, std::string callerId, std::string callerIdName, std::string calledDevice, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETDiverted, callId, divertedDevice, callerId, callerIdName, calledDevice, userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId in releasingDevice has been hung-up 
	virtual void	OnConnectionCleared ( MonitorXref xref, DWORD callId, std::string releasingDevice, call_cause cause) 
		{ Test_Event xEvent(eETConnCleared, callId, releasingDevice, "", "", "", "", cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// a call with callId has been completely destroyed 
	virtual void	OnCallCleared ( MonitorXref xref, DWORD callId, std::string userData, call_cause cause) 
		{ Test_Event xEvent(eETCallCleared, callId, "", "", "", "", userData, cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	/// provider link-down handler
	virtual void	OnLinkDown() {return;};

	// a call with callId has been holding by holdingDevice
	virtual void	OnHold ( MonitorXref xref, DWORD callId, std::string holdingDevice, call_cause cause) 
				{ Test_Event xEvent(eETHeld, callId, holdingDevice, "", "", "", "", cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};

	virtual void	OnUnhold ( MonitorXref xref, DWORD callId, std::string unholdingDevice, call_cause cause) 
			{ Test_Event xEvent(eETRetrieved, callId, unholdingDevice, "", "", "", "", cause); m_xEvents.insert( m_xEvents.begin(), xEvent);};
};


class ActivaTSP_Test_Adapter : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( ActivaTSP_Test_Adapter );
  CPPUNIT_TEST( test_case_518_calls_416 );
  CPPUNIT_TEST( test_case_109_calls_103 );
  CPPUNIT_TEST( test_predictive_1249560258_19156 );
  CPPUNIT_TEST( void_channel_newchannelevent );
  CPPUNIT_TEST( predictive_User_alerting_no_answer_1249560633_19283 );
  CPPUNIT_TEST( extension_to_extension_call_1251274964_5 );
  CPPUNIT_TEST( extension_to_isdn_call_1251279523_13 );
  //chan SIP Ast1.4 
  CPPUNIT_TEST( Asterisk_14_419_recives_call_from_422 );
  CPPUNIT_TEST( Asterisk_14_419_calls_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_14_419_recives_call_from_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_14_419_recives_call_from_queue_100_that_is_recived_from_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_14_419_originates_call_to_422 );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_and_it_is_recived_by_419 );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_busy );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_abandons );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_419_agent_answers_and_redirect_to_519 );

  //chan SIP Ast1.6
  CPPUNIT_TEST( Asterisk_16_419_recives_call_from_422 );
  CPPUNIT_TEST( Asterisk_16_419_calls_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_16_419_recives_call_from_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_422_by_SIP_trunk );
  CPPUNIT_TEST( Asterisk_16_419_originates_call_to_422 );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_and_it_is_recived_by_419 );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_busy );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_abandons );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_419_agent_answers_and_redirect_to_423 );
   //chan mISDN Ast1.4
  CPPUNIT_TEST( Asterisk_14_419_recives_call_from_queue_100_that_is_recived_from_318_by_mISDN_trunk );
  CPPUNIT_TEST( Asterisk_14_419_originates_call_to_318_by_mISDN_trunk );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_and_it_is_recived_by_419 );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_1318_busy );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_0666666666_by_mISDN_trunk_but_mobile_off );
   //chan mISDN Ast1.6
  CPPUNIT_TEST( Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_318_by_mISDN_trunk );
  CPPUNIT_TEST( Asterisk_16_419_originates_call_to_318_by_mISDN_trunk );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_and_it_is_recived_by_419 );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_1318_busy );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_0666666666_by_mISDN_trunk_but_mobile_off );

  //chan dahdi Ast1.6
  CPPUNIT_TEST( Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_422_by_dahdi_analog_trunk );
  CPPUNIT_TEST( Asterisk_16_419_originates_call_to_318_by_dahdi_analog_trunk );

  //chan IAX2 Ast1.4
  CPPUNIT_TEST( Asterisk_14_419_IAX2_ext_recives_call_from_queue_100_that_is_recived_from_519_by_IAX2_trunk );
  CPPUNIT_TEST( Asterisk_14_419_IAX2_ext_originates_call_to_3519_by_IAX2_trunk );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_and_it_is_recived_by_419_IAX2_ext );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_3519_busy );
  //chan IAX2 Ast1.6
  CPPUNIT_TEST( Asterisk_16_419_IAX2_ext_recives_call_from_queue_100_that_is_recived_from_519_by_IAX2_trunk );
  CPPUNIT_TEST( Asterisk_16_419_IAX2_ext_originates_call_to_3519_by_IAX2_trunk );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_and_it_is_recived_by_419_IAX2_ext );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_noAnswers );
  CPPUNIT_TEST( Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_3519_busy );

  //ast1.8
  CPPUNIT_TEST( Asterisk_18_419_recives_call_from_queue_101_that_is_recived_from_1234_by_SIP_trunk );
  
  //predictive_call_no_answer_on_iax
  CPPUNIT_TEST( predictive_call_no_answer_on_iax );
  //predictive_call_no_answer_on_sip_without_newstate
  CPPUNIT_TEST( predictive_call_no_answer_on_sip_without_newstate );
  //predictive_call_two_alerting_event_on_sip_newstateRinging_Dial_secuence
  CPPUNIT_TEST( predictive_call_two_alerting_event_on_sip_newstateRinging_Dial_secuence );
  //Universal queue test
  CPPUNIT_TEST( Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419 );
  CPPUNIT_TEST( Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419_but_abandons );
  CPPUNIT_TEST( Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419_but_make_one_RONA );
  CPPUNIT_TEST(	Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419 );
  CPPUNIT_TEST(	Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419_but_abandons );
  CPPUNIT_TEST(	Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419_but_make_one_RONA );

  CPPUNIT_TEST_SUITE_END();

  Test_ASTCstaListener	*m_pxCstaListener;
  ASTDummyLogListener	m_xLogger;
  ASTCstaProvider	*m_pxCstaProvider;

public:
   void setUp();
   void tearDown();

   //Test for detect CSTA layer regresions
   void test_case_518_calls_416(); 
   void test_case_109_calls_103(); 
   void test_predictive_1249560258_19156(); 
   void	void_channel_newchannelevent();
   void	predictive_User_alerting_no_answer_1249560633_19283();
   void	extension_to_extension_call_1251274964_5();
   void	extension_to_isdn_call_1251279523_13();
   
   //Test for detect Asterisk version regresions
   //chan SIP Ast14 
   void Asterisk_14_419_recives_call_from_422();
   void Asterisk_14_419_calls_422_by_SIP_trunk();
   void Asterisk_14_419_recives_call_from_422_by_SIP_trunk();
   void Asterisk_14_419_recives_call_from_queue_100_that_is_recived_from_422_by_SIP_trunk();
   void Asterisk_14_419_originates_call_to_422();
   void Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_and_it_is_recived_by_419();
   void Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_noAnswers();
   void Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_busy();
   void Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_abandons();
   void Asterisk_14_queue_100_originates_predictive_call_to_422_by_SIP_trunk_419_agent_answers_and_redirect_to_519();
   
   //chan SIP Ast16
   void Asterisk_16_419_recives_call_from_422();
   void Asterisk_16_419_calls_422_by_SIP_trunk();
   void Asterisk_16_419_recives_call_from_422_by_SIP_trunk();
   void Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_422_by_SIP_trunk();
   void Asterisk_16_419_originates_call_to_422();
   void Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_and_it_is_recived_by_419();
   void Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_noAnswers();
   void Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_busy();
   void Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_but_422_abandons();
   void Asterisk_16_queue_100_originates_predictive_call_to_422_by_SIP_trunk_419_agent_answers_and_redirect_to_423();

    //chan mISDN ast1.4
   void Asterisk_14_419_recives_call_from_queue_100_that_is_recived_from_318_by_mISDN_trunk();
   void Asterisk_14_419_originates_call_to_318_by_mISDN_trunk();
   void Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_and_it_is_recived_by_419();
   void Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_noAnswers();
   void Asterisk_14_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_1318_busy();
   void Asterisk_14_queue_100_originates_predictive_call_to_0666666666_by_mISDN_trunk_but_mobile_off();

   //chan mISDN ast1.6
   void Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_318_by_mISDN_trunk();
   void Asterisk_16_419_originates_call_to_318_by_mISDN_trunk();
   void Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_and_it_is_recived_by_419();
   void Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_noAnswers();
   void Asterisk_16_queue_100_originates_predictive_call_to_1318_by_mISDN_trunk_but_1318_busy();
   void Asterisk_16_queue_100_originates_predictive_call_to_0666666666_by_mISDN_trunk_but_mobile_off();

   //chan dahdi ast1.6
   void Asterisk_16_419_recives_call_from_queue_100_that_is_recived_from_422_by_dahdi_analog_trunk();
   void Asterisk_16_419_originates_call_to_318_by_dahdi_analog_trunk();

   //chan IAX2 Ast1.4
   void Asterisk_14_419_IAX2_ext_recives_call_from_queue_100_that_is_recived_from_519_by_IAX2_trunk();
   void Asterisk_14_419_IAX2_ext_originates_call_to_3519_by_IAX2_trunk();
   void Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_and_it_is_recived_by_419_IAX2_ext();
   void Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_noAnswers();
   void Asterisk_14_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_3519_busy();

   //chan IAX2 Ast1.6
   void Asterisk_16_419_IAX2_ext_recives_call_from_queue_100_that_is_recived_from_519_by_IAX2_trunk();
   void Asterisk_16_419_IAX2_ext_originates_call_to_3519_by_IAX2_trunk();
   void Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_and_it_is_recived_by_419_IAX2_ext();
   void Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_noAnswers();
   void Asterisk_16_queue_100_originates_predictive_call_to_3519_by_IAX2_trunk_but_3519_busy();
   
   //Ast1.8 incoming call
   void Asterisk_18_419_recives_call_from_queue_101_that_is_recived_from_1234_by_SIP_trunk();
   
   //
   void	predictive_call_no_answer_on_iax();
   void predictive_call_no_answer_on_sip_without_newstate();
   void predictive_call_two_alerting_event_on_sip_newstateRinging_Dial_secuence();

   //Universal Queue test
   void Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419();
   void Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419_but_abandons();
   void Asterisk_14_universal_queue_119_incoming_call_from_422_delivered_to_419_but_make_one_RONA();
   void Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419();
   void Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419_but_abandons();
   void Asterisk_14_universal_queue_119_predictive_call_to_422_delivered_to_419_but_make_one_RONA();

	
};

#endif  // ACTIVATSP_TEST_ADAPTER_H

#endif	//	__ACTIVATSP_CPPUNIT_BUILD
