/*
	Name: activatsp.cpp
	Copyright: Under the Mozilla Public License Version 1.1 or later
	Author: ACTIVA
	Date: MAY/06
*/

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Activa ActivaTSP.
 *
 * The Initial Developer of the Original Code is ACTIVA.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): none
 *
 * ***** END LICENSE BLOCK ***** */

#include <windows.h>
#include <string>
#include "resource.h"

#define DEFAULT_LOG_FILE_PATH "c:\\activaTSP.log"

bool registryInit(void);
bool registrySet(std::string key, std::string value);
bool registryGet(std::string key, std::string &value);
bool registrySet(std::string key, DWORD value);
bool registryGet(std::string key, DWORD &value);


// helpers
std::string	registryGetHostIp(std::string defaultValue) ;
void		registrySetHostIp(std::string value) ;

DWORD		registryGetHostPort(DWORD defaultValue) ;
void		registrySetHostPort(DWORD value) ;

std::string	registryGetLoginUser(std::string defaultValue) ;

std::string	registryGetLoginPassword(std::string defaultValue) ;

DWORD		registryGetLoginAuthType(DWORD defaultValue);

std::string	registryGetDnNamePrefix(std::string defaultValue) ;

DWORD		registryGetNumLines(DWORD defaultValue) ;

std::string	registryGetDn(int index) ;

std::string	registryGetCallerIdName(int index) ;

std::string	registryGetOutgoingContext(std::string defaultValue);

std::string	registryGetAgentContext(std::string defaultValue);

bool		registryIsTraceToFile(bool defaultValue) ;

int			registryGetLogLevel(int defaultValue) ;

std::string	registryGetLogFilePath(std::string defaultValue);

int		registryGetMaxLogFiles(int defaultValue);

int		registryGetLogFileSize(int defaultValue);

int		registryGetMaxBufferSize(int defaultValue);

std::string	registryGetOriginateVariable(std::string defaultValue) ;


// config dialog
BOOL CALLBACK ConfigDlgProc( HWND hwnd, UINT nMsg, WPARAM wparam, LPARAM lparam);

std::string	getVersion();




