;--------------------------------
; activatsp installer
;
;--------------------------------

!define PRODUCT_NAME "CallBoxTSP" 
!define PRODUCT_VERSION "1.8.1" 

!define INSTALLER_NAME "setupCallBoxTSP.exe" 

!define PRODUCT_PUBLISHER "Activa" 
!define PRODUCT_WEB_SITE "http://activa.sourceforge.net" 
!define PRODUCT_REGKEY "Software\ThinkroSystem_CallBoxTSP" 
!define PRODUCT_UNINSTALL_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" 
!define LICENSE_FILE "..\license.txt" 
!define ACTIVA_LOGO "..\..\html\activa_logo.gif"
!define LOG_FILE_PATH ""

;-------------------
; Include Modern UI
!include "MUI.nsh"

;-------------------
; x64 OS detection
!include "x64.nsh"

;-------------------
; general
; The name of the installer
Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"

/** Installer name */ 
OutFile "${INSTALLER_NAME}" 

;;;;!include "nsProcess.nsh"

Var /GLOBAL installationDir


InstallDirRegKey HKLM "${PRODUCT_REGKEY}" ""

;Mostramos todos los detalles del la instalacin al usuario.
ShowInstDetails show 
ShowUnInstDetails show 

;-------------------
; MUI settings
	!define MUI_ICON "callbox.ico"
	!define MUI_ABORTWARNING

; Pages 
	!insertmacro MUI_PAGE_LICENSE ${LICENSE_FILE} 
	!insertmacro MUI_PAGE_DIRECTORY 
	!insertmacro MUI_PAGE_INSTFILES 
	!insertmacro MUI_PAGE_FINISH 
 
	!insertmacro MUI_UNPAGE_CONFIRM 
	!insertmacro MUI_UNPAGE_INSTFILES 
	!insertmacro MUI_UNPAGE_FINISH 

;--------------------------------
;Languages
  !insertmacro MUI_LANGUAGE "English"

Function .onInit
	${If} ${RunningX64}
		MessageBox MB_OK|MB_ICONSTOP "This installer is for 32bit operating system, and 64 was detected! Intallation will abort."
		Abort
	${Else}
		
	${EndIf}


	Push $PROGRAMFILES
	Call GetParent
	Pop $installationDir
	StrCpy $INSTDIR $installationDir\ThinkroSystem\ActivaTSP

FunctionEnd

;--------------------------------
; Obtenir le rep parent

Function GetParent
 
  Exch $R0
  Push $R1
  Push $R2
  Push $R3
 
  StrCpy $R1 0
  StrLen $R2 $R0
 
  loop:
    IntOp $R1 $R1 + 1
    IntCmp $R1 $R2 get 0 get
    StrCpy $R3 $R0 1 -$R1
    StrCmp $R3 "\" get
  Goto loop
 
  get:
    StrCpy $R0 $R0 -$R1
 
    Pop $R3
    Pop $R2
    Pop $R1
    Exch $R0
 
FunctionEnd


;--------------------------------
Section BaseSection 

	ExecWait "$INSTDIR\registeractivatsp.exe /removesilently"
	
	Delete "$INSTDIR\registerActivaTSP.exe" 
	Delete "$WINDIR\activatsp.tsp" 
	Delete "$WINDIR\activatsp.pdb" 
	Delete "$WINDIR\activadll.dll" 
	Delete "$WINDIR\ActivaAPI.dll" 
	

	SetOutPath "$INSTDIR" 
	File "..\bin\release\registerActivaTSP.exe"
	File ".\vcredist_x86.exe"

	SetOutPath "$WINDIR" 
	File "..\bin\release\ActivaTSP.tsp"
	File "..\bin\release\ActivaTSP.pdb"
	File "..\bin\release\ActivaAPI.dll"
	File "..\bin\release\ActivaAPI.pdb"
	
	; Installs for all system users
	SetShellVarContext all
SectionEnd 


Section -Post 

	/* vcredist */
	ExecWait "$INSTDIR\vcredist_x86.exe"

	/** MSVCREDISTRIBUTABLE. */ 
	Delete "$INSTDIR\vcredist_x86.exe"
	
	; Stores installation folder 
	WriteRegStr HKLM "${PRODUCT_REGKEY}" "" $INSTDIR 

	; Creates uninstaller 
	WriteUninstaller "$INSTDIR\uninstall.exe" 

	
	WriteRegStr HKLM "${PRODUCT_UNINSTALL_KEY}" "DisplayName" "$(^Name)" 
	WriteRegStr HKLM "${PRODUCT_UNINSTALL_KEY}" "UninstallString" "$INSTDIR\uninstall.exe" 
	WriteRegStr HKLM "${PRODUCT_UNINSTALL_KEY}" "DisplayVersion" "${PRODUCT_VERSION}" 
	WriteRegStr HKLM "${PRODUCT_UNINSTALL_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}" 
	WriteRegStr HKLM "${PRODUCT_UNINSTALL_KEY}" "Publisher" "${PRODUCT_PUBLISHER}" 
	WriteRegDWORD HKLM "${PRODUCT_UNINSTALL_KEY}" "NoModify" 1
	WriteRegDWORD HKLM "${PRODUCT_UNINSTALL_KEY}" "NoRepair" 1
	
	ExecWait "$INSTDIR\registeractivatsp.exe /install "
SectionEnd 


UninstallIcon "callbox.ico"

Section Uninstall 
	ExecWait "$INSTDIR\registeractivatsp.exe /remove"

	;Remove from install / uninstall program list 
	DeleteRegKey HKLM "${PRODUCT_UNINSTALL_KEY}"

	; Remove register keys
	DeleteRegKey HKLM "${PRODUCT_REGKEY}"
	
	; Remove files and uninstaller
	Delete $WINDIR\activatsp.tsp
	Delete $WINDIR\activatsp.pdb
	Delete $WINDIR\activaAPI.dll
	Delete $WINDIR\activaAPI.pdb
	Delete $INSTDIR\registeractivatsp.exe
	Delete $INSTDIR\uninstall.exe
	RMDir /r $INSTDIR
SectionEnd 

